SET SERVEROUTPUT ON 
- ESBORRAR I CREACIO DE TAULES I TRIGGERS 


DROP TABLE LECTURES	CASCADE CONSTRAINTS PURGE;
DROP TABLE CONTRACTE	CASCADE CONSTRAINTS PURGE;
DROP TABLE CONNCOMPTADOR CASCADE CONSTRAINTS PURGE;
DROP TABLE COMPTADOR	CASCADE CONSTRAINTS PURGE;
DROP TABLE MODELCOMPT	CASCADE CONSTRAINTS PURGE;
DROP TABLE CLIENT	CASCADE CONSTRAINTS PURGE;
DROP TABLE CONNLINIA	CASCADE CONSTRAINTS PURGE;
DROP TABLE CENTRALDIST	CASCADE CONSTRAINTS PURGE;
DROP TABLE LINIA	CASCADE CONSTRAINTS PURGE;
DROP TABLE CPNUCLEAR	CASCADE CONSTRAINTS PURGE;
DROP TABLE CPEOLICA	CASCADE CONSTRAINTS PURGE;
DROP TABLE CPSOLAR	CASCADE CONSTRAINTS PURGE;
DROP TABLE CPTERMICA	CASCADE CONSTRAINTS PURGE;
DROP TABLE CPCARBO	CASCADE CONSTRAINTS PURGE;
DROP TABLE HISTORICCPROD CASCADE CONSTRAINTS PURGE;
DROP TABLE CENTRALPROD	CASCADE CONSTRAINTS PURGE;
DROP TABLE ME1 CASCADE CONSTRAINTS PURGE;
DROP TABLE ME2 CASCADE CONSTRAINTS PURGE;
DROP TABLE ME3 CASCADE CONSTRAINTS PURGE;
DROP TABLE ME4 CASCADE CONSTRAINTS PURGE;
DROP TABLE ME5 CASCADE CONSTRAINTS PURGE;
DROP TABLE ME6 CASCADE CONSTRAINTS PURGE;
DROP TABLE ME7 CASCADE CONSTRAINTS PURGE;

DROP TABLE TAULALOG	CASCADE CONSTRAINTS PURGE;


CREATE TABLE MODELCOMPT(
	idModel NUMBER(6) NOT NULL,
	fabricant VARCHAR2(20) NOT NULL,
	modelCompt VARCHAR2(15) NOT NULL,
	maxKW NUMBER(4,1) NOT NULL,
	CONSTRAINT PK_MODEL PRIMARY KEY(idModel));


CREATE TABLE COMPTADOR(
	idComptador NUMBER(10) NOT NULL,
	idModel NUMBER(6) NOT NULL,
	adreca VARCHAR2(30) NOT NULL,
	codiPostal CHAR(5) NOT NULL,
	localitat VARCHAR2(30) NOT NULL,
	pais VARCHAR2(20) NOT NULL,
	consumAbsolut NUMBER(8,1) NOT NULL,
	consumMensual NUMBER(8,1) NOT NULL,
	dataLectura DATE ,
	anyFabricacio NUMBER(4) NOT NULL,
        dataBaixa date,
	CONSTRAINT PK_COMPTADOR PRIMARY KEY(idComptador),
        CONSTRAINT FK_COMPTADOR FOREIGN KEY (idModel) REFERENCES MODELCOMPT ON DELETE CASCADE);


CREATE TABLE LECTURES(
	idLectura NUMBER(10) NOT NULL,
	idComptador NUMBER(10) NOT NULL,
	dataLecturaAnt DATE,
	dataLectura DATE NOT NULL,
	lecturaAnt  NUMBER(8,1) NOT NULL,
	lecturaActual NUMBER(8,1) NOT NULL,
	consumLectura NUMBER(8,1) NOT NULL,
	tipusLectura CHAR(1) NOT NULL,
        esborrat NUMBER(1) NOT NULL,
	CONSTRAINT PK_LECTURES PRIMARY KEY(idLectura),
	CONSTRAINT FK_LECTURES FOREIGN KEY(idComptador) REFERENCES COMPTADOR ON DELETE CASCADE);


CREATE TABLE CLIENT(
	idClient NUMBER(10) NOT NULL,
	NIF 	CHAR(9) NOT NULL,
	tipusClient CHAR(1) NOT NULL,
	nom	VARCHAR2(20) NOT NULL,
	cognom1 VARCHAR2(20),
	cognom2 VARCHAR2(20),
	adreca VARCHAR2(30) NOT NULL,
	codiPostal CHAR(5) NOT NULL,
	localitat VARCHAR2(30) NOT NULL,
	pais VARCHAR2(20) NOT NULL,
	dataAntiguitat DATE NOT NULL,
        dataBaixa DATE,
	CONSTRAINT PK_CLIENT PRIMARY KEY(idClient));

CREATE TABLE CONTRACTE(
	codi	NUMBER(10) NOT NULL,
	idComptador NUMBER(10) NOT NULL,
	idClient NUMBER(10) NOT NULL,
	KWContractats NUMBER(4,1) NOT NULL,
	dataAlta DATE NOT NULL,
	dataBaixa DATE,
	consumAlta number(8,1) NOT NULL,
	consumBaixa number(8,1),
	CONSTRAINT PK_CONTRACTE PRIMARY KEY(codi),
	CONSTRAINT FK_CONTRACTE_COMPTADOR FOREIGN KEY(idComptador) REFERENCES COMPTADOR ON DELETE CASCADE,
	CONSTRAINT FK_CONTRACTE_CLIENT FOREIGN KEY(idClient) REFERENCES CLIENT ON DELETE CASCADE);



CREATE TABLE CENTRALDIST(
	idCDist NUMBER(10) NOT NULL,
	adreca VARCHAR2(30) NOT NULL,
	codiPostal chaR(5) NOT NULL,
	localitat VARCHAR2(30) NOT NULL,
	pais VARCHAR2(20) NOT NULL,
	maxKWh NUMBER(12,1) NOT NULL,
	dataFuncionament DATE NOT NULL,
        dataBaixa DATE,
	CONSTRAINT PK_CENTRALDIST PRIMARY KEY(idCDist),
	CONSTRAINT PK_CENTRALDIST_ADRECA UNIQUE (adreca,codiPostal,localitat,pais));



CREATE TABLE CONNCOMPTADOR(
	idComptador NUMBER(10) NOT NULL,
	idCDist NUMBER(10) NOT NULL,
	KWhConnexio NUMBER(8,1) NOT NULL,
	tipusConn char(1) NOT NULL,
	estat number(1) NOT NULL,
	CONSTRAINT PK_CONNCOMPTADOR PRIMARY KEY(idComptador,idCDist),
	CONSTRAINT FK_CONNCOMPTADOR_COMPTADOR FOREIGN KEY(idComptador) REFERENCES COMPTADOR ON DELETE CASCADE,
	CONSTRAINT FK_CONNCOMPTADOR_CDIST FOREIGN KEY(idCDist) REFERENCES CENTRALDIST ON DELETE CASCADE	);


CREATE TABLE LINIA(
	idLinia NUMBER(10) NOT NULL,
	maxKWh NUMBER(12,1) NOT NULL,
	dataBAixa DATE,
	CONSTRAINT PK_LINIA PRIMARY KEY(idLinia));


CREATE TABLE CENTRALPROD(
	idCProd NUMBER(10) NOT NULL,
	adreca VARCHAR2(30) NOT NULL,
	codiPostal CHAR(5) NOT NULL,
	localitat VARCHAR2(30) NOT NULL,
	pais VARCHAR2(20) NOT NULL, 
	maxKWh NUMBER(12,1) NOT NULL,
	dataDarreraInspecc DATE NOT NULL,
	dataFuncionament DATE NOT NULL,
        tipusCProd VARCHAR(10) NOT NULL,
        dataBaixa DATE,
	CONSTRAINT PK_CENTRALPROD PRIMARY KEY(idCProd));


CREATE TABLE CONNLINIA(
	idCDist NUMBER(10) NOT NULL,
	idLinia NUMBER(10) NOT NULL,
	idCProd NUMBER(10) NOT NULL,
	tipusConn char(1) NOT NULL,
	estat NUMBER(1) NOT NULL,
	CONSTRAINT PK_CONNLINIA PRIMARY KEY(idCDist, idLinia, idCProd),
	CONSTRAINT FK_CONNLINIA_CDIST FOREIGN KEY(idCDist) REFERENCES CENTRALDIST ON DELETE CASCADE,
	CONSTRAINT FK_CONNLINIA_LINIA FOREIGN KEY(idLinia) REFERENCES LINIA ON DELETE CASCADE,
	CONSTRAINT FK_CONNLINIA_CPROD FOREIGN KEY(idCProd) REFERENCES CENTRALPROD ON DELETE CASCADE);




CREATE TABLE CPNUCLEAR(
	idCProd NUMBER(10) NOT NULL,
	energiaMin NUMBER(12,1) NOT NULL,
	KgRebuig NUMBER(12,1) NOT NULL,
	CONSTRAINT PK_CPNUCLEAR PRIMARY KEY(idCProd),
	CONSTRAINT FK_CP_NUCLEAR FOREIGN KEY(idCProd) REFERENCES CENTRALPROD);



CREATE TABLE CPEOLICA(
	idCProd NUMBER(10) NOT NULL,
	numMolins NUMBER(6) NOT NULL,
	CONSTRAINT PK_CPEOLICA PRIMARY KEY(idCProd),
 	CONSTRAINT FK_CPEOLICA FOREIGN KEY(idCProd) REFERENCES CENTRALPROD);


CREATE TABLE CPSOLAR(
	idCProd NUMBER(10) NOT NULL,
	numPanels NUMBER(6) NOT NULL,
	CONSTRAINT PK_CPSOLAR PRIMARY KEY(idCProd),
	CONSTRAINT FK_CPSOLAR FOREIGN KEY(idCProd) REFERENCES CENTRALPROD);



CREATE TABLE CPTERMICA(
	idCProd NUMBER(10) NOT NULL,
	KgEmissions NUMBER(12,1) NOT NULL,
        CONSTRAINT PK_CPTERMICA PRIMARY KEY(idCProd),
	CONSTRAINT FK_CPTERMICA FOREIGN KEY(idCprod) REFERENCES CENTRALPROD);


CREATE TABLE CPCARBO(
	idCProd NUMBER(10) NOT NULL,
	KgEmissions NUMBER(12,1) NOT NULL,
	CONSTRAINT PK_CPCARBO PRIMARY KEY(idCProd),
	CONSTRAINT FK_CPCARBO FOREIGN KEY(idCProd) REFERENCES CENTRALPROD);


CREATE TABLE HISTORICCPROD(
	idCProd NUMBER(10) NOT NULL,
	dataProd DATE NOT NULL,
	KWhProduits NUMBER(12,1) NOT NULL,
	CONSTRAINT PK_HISTORICCPROD PRIMARY KEY(idCProd, dataProd),
	CONSTRAINT FK_HISTORICCPROD FOREIGN KEY(idCProd) REFERENCES CENTRALPROD);

CREATE TABLE TAULALOG(
	idLog NUMBER(12) NOT NULL,
	procExecutat VARCHAR2(50) NOT NULL,
	paramEntrada VARCHAR2(300) NOT NULL,
	paramSortida VARCHAR2(300) NOT NULL,
	RSP VARCHAR2(300) NOT NULL,
	dataHora TIMESTAMP NOT NULL,
	CONSTRAINT PK_LOG PRIMARY KEY(idLog));


CREATE TABLE ME1(
	idCProd NUMBER(10) NOT NULL,
	consum NUMBER(12,1) NOT NULL,
	CONSTRAINT PK_ME1 PRIMARY KEY(idCProd),
	CONSTRAINT FK_ME1 FOREIGN KEY(idCProd) REFERENCES CENTRALPROD);



CREATE TABLE ME2(
	idLinia NUMBER(10) NOT NULL,
	anyo NUMBER(4) NOT NULL,
	energiaMitja NUMBER(12,4) NOT NULL,
	numComptadors NUMBER (10) NOT NULL,
	CONSTRAINT PK_ME2 PRIMARY KEY(idLinia,anyo),
	CONSTRAINT FK_ME2 FOREIGN KEY(idLinia) REFERENCES LINIA);


CREATE TABLE ME3(
	posRanking NUMBER(10) NOT NULL,
	idLinia NUMBER(10) NOT NULL,
	consum NUMBER(12,4) NOT NULL,
	CONSTRAINT PK_ME3 PRIMARY KEY(posRanking),
	CONSTRAINT FK_ME3 FOREIGN KEY(idLinia) REFERENCES LINIA);


CREATE TABLE ME4(
	anyo NUMBER(4) NOT NULL,
	percentLinies NUMBER(5,2) NOT NULL,
	CONSTRAINT PK_ME4 PRIMARY KEY(anyo));

CREATE TABLE ME5(
	anyo NUMBER(4) NOT NULL,
	nombreCProd NUMBER(8) NOT NULL,
	CONSTRAINT PK_ME5 PRIMARY KEY(anyo));



CREATE TABLE ME6 (
	posRanking number(6) NOT NULL,
	idComptador NUMBER(10) NOT NULL,
	consumAbsolut NUMBER(12,1) NOT NULL,
	CONSTRAINT PK_ME6 PRIMARY KEY(posRanking),
	CONSTRAINT FK_ME6 FOREIGN KEY(idComptador) REFERENCES COMPTADOR );


CREATE TABLE ME7 (
	idME7 NUMBER(1) NOT NULL,
	nombreClients NUMBER(8) ,
	nombrePersones NUMBER(8),
	nombreEmpreses  NUMBER(8),
	consumTotal	NUMBER(12,1),
	consumPersones NUMBER(12,1),
	consumEmpreses NUMBER(12,1),
	consumMig	NUMBER(12,1) NOT NULL,
	CONSTRAINT PK_ME7 PRIMARY KEY(idME7));




-- TRIGGERS SEQNCIA	

  	
create or replace TRIGGER TR_INSERTMODELCOMPT BEFORE INSERT ON MODELCOMPT 
FOR EACH ROW 
BEGIN
	IF (:NEW.idModel =0 ) THEN
        SELECT S_IDMODEL.NEXTVAL INTO :NEW.idModel
	FROM DUAL;
        END IF;
	END TR_INSERTMODELCOMPT;

/


CREATE OR REPLACE
TRIGGER TR_INSERT_COMPTADOR BEFORE INSERT ON COMPTADOR 
FOR EACH ROW 
BEGIN
	IF (:NEW.idComptador = 0 ) THEN
        SELECT S_IDCOMPTADOR.NEXTVAL INTO :NEW.idComptador
	FROM DUAL;
        END IF;
	END TR_INSERt_COMPTADOR;
/



create or replace trigger TR_INSERT_LECTURES
	BEFORE insert on LECTURES
	for each row
	BEGIN
	IF (:NEW.idLectura = 0) THEN
	SELECT S_IDLECTURA.NEXTVAL INTO :NEW.idLectura
	FROM DUAL;
	END IF;
	END TR_INSERT_LECTURES;

/


CREATE OR REPLACE
TRIGGER TR_INSERT_CLIENT BEFORE INSERT ON CLIENT 
FOR EACH ROW 
BEGIN
	if (:new.idClient = 0) THEN
	SELECT S_IDCLIENT.NEXTVAL INTO :NEW.idClient
	FROM DUAL;
	END IF;
	END TR_INSERT_CLIENT;

/





CREATE OR REPLACE
TRIGGER TR_INSERT_CONTRACTE BEFORE INSERT ON CONTRACTE 
FOR EACH ROW 
BEGIN
	IF (:NEW.CODI = 0) THEN
	SELECT S_CODI.NEXTVAL INTO :NEW.codi
	FROM DUAL;
	END IF;
	END TR_INSERT_CONTRACTE;

/


create or replace trigger TR_INSERT_CENTRALDIST
	BEFORE insert on CENTRALDIST
	for each row
	BEGIN
	IF (:NEW.IDCDIST =0) THEN
	SELECT S_IDCDIST.NEXTVAL INTO :NEW.idCDist
	FROM DUAL;
	END IF;
	END TR_INSERT_CENTRALDIST;

/



create or replace trigger TR_INSERT_LINIA
	BEFORE insert on LINIA
	for each row
	BEGIN
	IF (:NEW.IDLINIA = 0) THEN
	SELECT S_IDLINIA.NEXTVAL INTO :NEW.idLinia
	FROM DUAL;
	END IF;
	END TR_INSERT_LINIA;

/




create or replace trigger TR_INSERT_TAULALOG
	BEFORE insert on TAULALOG
	for each row
	BEGIN
	SELECT S_IDLOG.NEXTVAL INTO :NEW.idLog FROM DUAL;
	
	
	END TR_INSERT_LOG;

/



