CREATE OR REPLACE
PROCEDURE PR_ACTUALITZAR_ME4 (

RSP OUT NOCOPY taulalog.RSP%TYPE

)

--/*****************************************************************************
--  PROCEDIMENT:  PR_ACTUALITZAR_ME4
-- 
--  CALCULA EL PERCENTATGE DE LINIES QUE SUPEREN EL 50% D'ENERGIA CONSUMIDA 
--  RESPECTE AL SEU MXIM POSSIBLE ANUAL. SEPARANT EL RESULTAT PER ANYS. 

--  S'APROFITA QUE A LA TAULA M2 DE MODUL ESTADISTIC TENIM PER CADA ANY I LINIA
--  EL CONSUM MITJ I NUMERO DE COMPTADORS PER CALCULAR EN AQUEST MODUL EL 
--  CONSUM ANUAL DE CADA LINIA MULTIPLICANT CONSUM MITJ X NUM. COMPTADORS. 
--  (AIX NO S'HA DE CALCULAR SUMANT ELS CONSUMS DE LA TAULA LECTURES I S 
--  MS EFICIENT JA QUE S'ESTALVIEN OPERACIONS).
--
--  Aquest procediment es crida al donar d'alta una lectura a PR_ALTA_LECTURA.
--
--  Tant si hi ha errors com si insertem el registre a la taula, s'afegeix a la 
--  TAULALOG el resultat de la operaci.
--    
--  ENTRADA : NO TE PARMETRES D'ENTRADA
--              
--   SORTIDA : RSP indicant si ha anat correcte o si ha hagut errors.
--          
--   RSP = OK : S'inserta registre a la taula ME6.
--   RSP = ERROR + motiu, si hi ha algn error.
--
--   Motius Error : Altres.
--     
--******************************************************************************/

IS
        -- Variable de select de taula
        t_maxKWhLinia LINIA.MAXKWH%type;
        
        -- variables de cursor 
        c_anyo ME2.ANYO%TYPE;
        c_idLinia ME2.idLinia%TYPE;
        c_consumAny COMPTADOR.consumAbsolut%TYPE;
       
        -- variables de insert taulaLOG
        nomProcediment taulaLog.procExecutat%TYPE := 'PR_ACTUALITZAR_ME4';
	paramEntrada taulaLog.paramEntrada%TYPE := 'NO REP PARMETRES' ;
	paramSortida taulaLog.paramSortida%TYPE := 'RSP';
      

        -- variables d'us divers (comptadors, etc)
        numElements number :=0;
        numLinies number :=0;
        cont number := 0;
        
        
        -- variable on podem canviar el percentatge proposat a l'enunciat
        percentatge number:= 50;
       
        -- variable que serveix per saber si ha canviat l'any del fetch
        anyo_temp ME2.ANYO%type;
        
        -- CURSOR ON ES GUARDARAN ELS ANYS, LINIA I CONSUM DE L'ANY DE LA LINIA
        
        CURSOR cur_resultat_ME4 is
        SELECT ME2.anyo, ME2.idLinia, ME2.ENERGIAMITJA * ME2.NUMCOMPTADORS AS CONSUMANY
            FROM ME2
            ORDER BY ME2.ANYO, ME2.idLinia;
            
      
BEGIN
     
     -- CONTEM ELS NUMEROS DE LINIES QUE HI HA (QUE CORRESPON AL 100% DE LES LINIES)
     SELECT COUNT(*) INTO numLinies
     FROM LINIA;
      
     OPEN cur_resultat_ME4;
     FETCH cur_resultat_ME4 INTO c_anyo, c_idLinia, c_consumAny;
            IF cur_resultat_ME4%NOTFOUND 
              THEN DBMS_OUTPUT.PUT_LINE('NO HI HA REGISTRES AL MODUL ESTADISTIC 2 D''ON AGAFAR LES DADES');
            ELSE 
                -- SI HI HA REGISTRES A ME2 
                WHILE  cur_resultat_ME4%FOUND  loop
                
                -- SEGONS LA LINIA LLEGIDA DEL CURSOR, SELECCIONEM EL SEU MAXIM DE KWH QUE POT SUBMINISTRAR ANUAL
                -- PER VEURE SI EL CONSUM LLEGIT D'AQUELL ANY SOBREPASSA EL 50% 
                -- SI HO SOBREPASSA, SUMEM 1 A NUMELEMENTS PER CALCULAR EL PERCENTATGE DE LINIES AL INSERTAR A M4
                
                  SELECT LINIA.MAXKWH INTO t_maxKWhLinia FROM LINIA WHERE LINIA.IDLINIA = c_idLinia;  
                  IF c_consumAny > (t_maxKWhLinia * percentatge)/100 THEN numElements := numElements +1; END IF;
                  
                 -- DBMS_OUTPUT.PUT_LINE('LINIA :'||c_IDLINIA||' CONSUM ANY:'|| c_consumAny|| ' 50% MAX LINIA:'||(t_maxKWhLinia * percentatge)/100);
                  anyo_temp := c_anyo;  
      
                FETCH cur_resultat_ME4 INTO c_anyo, c_idLinia, c_consumAny;
             
              -- SI CANVIA D'ANY AL CURSOR, O TAN SOLS HI HAVIA UN REGISTRE AL CURSOR, 
              -- LLAVORS UPDATEM A LA TAULA M4 L'ANY TRACTAT (O INSERTEM SI S NOU)
              -- I POSEM EL PERCENTATGE DE LINIES QUE SUPEREN EL 50% 
              -- (O PERCENTATGE INDICAT) DE LA SEVA CAPACITAT MXIMA.
                 
                      IF anyo_temp <> c_anyo OR cur_resultat_me4%notfound  THEN
                          SELECT COUNT(*) INTO cont FROM ME4 WHERE anyo_temp = ME4.anyo;
                              IF CONT = 0 THEN
                                INSERT INTO ME4 VALUES (anyo_temp, (numElements/numLinies)*100);
                              ELSE
                                UPDATE ME4 SET   ME4.percentLinies = (numElements/numLinies*100)
                                           WHERE ME4.anyo = anyo_temp;
                              END IF;
                          -- REINICIEM EL COMPTADOR DE LINIES QUE SUPEREN EL SEU PERCENTATGE D'ENERGIA
                          numElements := 0;
                
                      END IF;
                 END LOOP;
   
                CLOSE cur_resultat_ME4;  
    
              END IF;
   
   COMMIT;  
   
   RSP := 'OK';
  PR_INSERT_LOG( nomProcediment,paramEntrada, paramSortida, RSP,  sysdate);
           
EXCEPTION
           
	WHEN STORAGE_ERROR THEN
		RSP := 'ERROR: ERROR AL EMMAGATZEMAR';
		PR_INSERT_LOG(nomProcediment,paramEntrada, paramSortida, RSP,  sysdate);	
		ROLLBACK;
                
      
	WHEN OTHERS THEN
		RSP := 'ERROR: ERROR SENSE TRACTAR A PR_ACTUALITZAR_ME4 - '||SQLCODE||'-'||SQLERRM;
		PR_INSERT_LOG( nomProcediment,paramEntrada, paramSortida, RSP, sysdate);	
		ROLLBACK;
	
END;
/