CREATE OR REPLACE
PROCEDURE PR_ACTUALITZAR_ME6 (

p_idcomptador IN COMPTADOR.idCOMPTADOR%TYPE,
p_consumAbsolut IN COMPTADOR.consumAbsolut%TYPE,

RSP OUT NOCOPY taulalog.RSP%TYPE
)

--/*****************************************************************************
--  PROCEDIMENT:  PR_ACTUALITZAR_ME6

--  AQUEST PROCEDIMENT ES CRIDA DESPRS D'INSERTAR UNA LECTURA A P_ALTA_LECTURA
--  
--  AMB EL COMPTADOR I EL CONSUM ABSOLUT DEL COMPTADOR  DESPRS DE
--  INSERTAR LA LECTURA, ACTUALITZEM LA TAULA ME6 ON ESTARAN ELS 10 COMPTADORS
--  QUE HAGIN CONSUMIT MS EN TERMES ABSOLUTS.
--  
--  LO MS FCIL SERIA ORDENAR TOTS ELS COMPTADORS I AGAFAR ELS 10 PRIMERS,
--  PER A LA VIDA REAL SERIEN MASSA REGISTRES A ORDENAR. PER VEURE QUIN SON ELS QUE
--  MS CONSUMEIXEN, HO FAIG INSERTANT EL CONSUM I COMPTADOR AQUESTS A LA TAULA ME6 (QUE
--  TINDR 10 REGISTRES + L'INSERTAT ), ORDENANT-LA PER CONSUM I 
--  TORNARLA A ESCRIURE AMB EL RANKING.
--  (AIX EN COMPTES D'ORDENAR MOLTS COMPTADORS, S'ORDENARAN NOMS +- 10 REGISTRES).

-- NOTA: ABANS D'INTRODUR LES DADES DE LECTURES, ES POT MODIFICAR LES VARIABLES
--       D'AQUEST PROCEDIMENT (I TORNAR A COMPILAR)
--       PER FER EL LLISTAT DE TIPUS "ESTRICTE" (10 POSICIONS EXACTES) O
--       SI NO, QUE EN CAS D'EMPAT A LA LTIMA POSICI, AGAFI ELS SEGENTS TAMB.
--  
--  Tant si hi ha errors com si insertem el registre a la taula, s'afegeix a la 
--  TAULALOG el resultat de la operaci.
--    
--  ENTRADA : Ip_IDCOMPTADOR  NUMBER(10) , p_CONSUMABSOLUT  NUMBER(8,1) .
--              
--   SORTIDA : RSP indicant si ha anat correcte o si ha hagut errors.
--          
--   RSP = OK : S'inserta registre a la taula ME6.
--   RSP = ERROR + motiu, si hi ha algn error.
--
--   Motius Error :
--      - ERROR: HI HA NULS ALS PARAMETRES D'ENTRADA.
--      - Altres.
--      
--
--******************************************************************************/

IS
	-- variable error
        e_camps_nuls EXCEPTION;
       
        -- variables insert a taulaLOG
        nomProcediment taulaLog.procExecutat%TYPE := 'PR_ACTUALITZAR_ME6';
	paramEntrada taulaLog.paramEntrada%TYPE := 'P_idComptador: ' || p_idComptador || ', p_consumAbsolut : ' || p_consumAbsolut;
	paramSortida taulaLog.paramSortida%TYPE := 'RSP';
 
        -- variables d'us divers (comptadors bucles, temporals etc)
        numElements number :=0;
        cont number :=0;
        existeix_a_M6 number :=0;
        consum_Temp ME6.consumAbsolut%TYPE;
       
       -- variables de configuraci      
       maxposicions number := 10;
       tipusLlistat VARCHAR(20) := 'ESTRICTE';
       
--   NOTA: MAXPOSICIONS INDICA LES POSICIONS QUE TINDR EL RNKING.
--      SI TIPUS LLISTAT S 'ESTRICTE', EL RNKING HO ANIR FENT ESTRICTE (TINDR LES
--      POSICIONS INDICADES, I EN CAS D'EMPAT A LA LTIMA POSICI
--      S'AGAFAR EL DEL IDCOMPTADOR MS GRAN)
--      SI TIPUS LLISTAT NO S  'ESTRICTE' LLAVORS EN CAS D'EMPAT A LA LTIMA POSICI
--      S'AGAFARN TOTS ELS COMPTADORS SEGENTS QUE TINGUIN
--      AQUEST CONSUM, JA QUE S UN EMPAT TCNIC)
---    
--   PER DEFECTE ES CREAR AMB 10 POSICIONS -  TIPUS ESTRICTE. 
--   SI S'HA DE MODIFICAR, S'HA DE FER ABANS D'INSERIR DADES DE LECTURA.

        
        -- variables de cursor
        
        c_posRanking ME6.POSRANKING%type;
        c_idComptador ME6.idComptador%TYPE;
        c_consumAbsolut ME6.consumAbsolut%TYPE;
        
        
        
        -- DEFINIM EL CURSOR DEL RESULTAT QUE SER EL CONTINGUT DE LA TAULA ME6
        -- CORRESPONENT AL RESULTAT. AQUESTA TAULA TINDR ELS COMPTADORS AMB
        -- ELS 10 CONSUMS ABSOLUTS MS GRANS.
        
        CURSOR c_resultat_ME6 is
        SELECT ME6.posRanking, ME6.idComptador, ME6.consumAbsolut
            FROM ME6
            ORDER BY ME6.consumAbsolut desc, ME6.IDCOMPTADOR;
      
      
BEGIN
 
     -- VERIFIQUEM ELS NULS DELS PARAMETRES D'ENTRADA
      IF   (p_idComptador is null) or (p_consumAbsolut is null)
          THEN RAISE e_camps_nuls;
      END IF;
    
      cont := 1;
      
      select count(*) into numElements
      FROM ME6;
            
    -- si idcomptador no est a taula ME6 insertem al final els valors passats per parmetre.
    -- Si existeix, updatem el consumAbsolut.
    -- AL OBRIR EL CURSOR, ORDENAR LA TAULA I S'AGAFARAN ELS 10 PERTINENTS
     
     Select count(*) into existeix_a_M6
     FROM ME6 wHERE p_idComptador = idComptador;
     
     IF existeix_a_M6 <> 0 THEN
       UPDATE ME6 SET consumAbsolut = p_consumAbSolut WHERE p_idComptador = idcomptador;
     ELSE
       INSERT INTO ME6 VALUES (numElements+1, P_idComptador, P_consumAbsolut);
     END IF;
     commit;
     
      
     OPEN c_resultat_ME6;
     -- ESBORRO EL CONTINGUT DE LA TAULA 
     delete me6;
     
     FETCH c_resultat_ME6 INTO c_posRanking, c_idComptador, c_consumAbsolut;
    
            IF c_resultat_ME6%NOTFOUND 
              THEN DBMS_OUTPUT.PUT_LINE('NO HI HA REGISTRES A LLISTAR');
            ELSE 
               WHILE  c_resultat_ME6%FOUND LOOP
                  
                  IF cont <= maxposicions  THEN                          
                    INSERT INTO ME6 VALUES (cont, c_idComptador, c_consumAbsolut);
                  END IF;
                
                -- Si el consum del segent s el mateix que el de la posici ltima
                -- i si TIPUS LLISTAT NO s 'ESTRICTE' aquest ho posem 
                -- tamb a la taula, ja que s un empat tcnic a la ltima posici.
                  IF tipusLlistat <> 'ESTRICTE' THEN
                    IF cont > maxposicions AND consum_Temp = c_consumAbsolut
                       THEN 
                        INSERT INTO ME6 VALUES (cont, c_idComptador, c_consumAbsolut);
                    END IF;
                 END IF;
                
              -- agafem el consum de la posici 10 (o mxim de posicions) per si el segent t 
              -- el mateix consum, posar-lo tamb al llistat, si no s de tipus 'ESTRICTE' 
                IF cont = maxposicions THEN consum_Temp := c_consumAbsolut; END IF;
              
              FETCH c_resultat_ME6 INTO c_posRanking, c_idComptador, c_consumAbsolut;
              cont := cont  +1;
              END LOOP;
    
            CLOSE c_resultat_ME6;  
    
          END IF;
   
   COMMIT;  
   
   RSP := 'OK';
   PR_INSERT_LOG( nomProcediment,paramEntrada, paramSortida, RSP,  sysdate);
      
EXCEPTION

	WHEN e_camps_nuls THEN
        	RSP := 'ERROR: HI HA NULS ALS PARAMETRES D''ENTRADA';
		PR_INSERT_LOG(nomProcediment,paramEntrada, paramSortida, RSP, sysdate);
		DBMS_OUTPUT.PUT_LINE(RSP);
        	Rollback;
                  
               
	WHEN STORAGE_ERROR THEN
		RSP := 'ERROR: ERROR AL EMMAGATZEMAR';
		PR_INSERT_LOG( nomProcediment,paramEntrada, paramSortida, RSP,  sysdate);	
		ROLLBACK;
                
      
	WHEN OTHERS THEN
		RSP := 'ERROR: ERROR SENSE TRACTAR A PR_ACTUALITZAR_ME6 - '||SQLCODE||'-'||SQLERRM;
		PR_INSERT_LOG(nomProcediment,paramEntrada, paramSortida, RSP, sysdate);	
		ROLLBACK;
	
END;
/