CREATE OR REPLACE
PROCEDURE PR_ACTUALITZAR_ME7 (

RSP OUT NOCOPY taulalog.RSP%TYPE

)

--/*****************************************************************************
--  PROCEDIMENT:  PR_ACTUALITZAR_ME7

--  AQUEST PROCEDIMENT ES CRIDA DESPRS D'INSERTAR UNA LECTURA
--  CALCULA EL CONSUM MIG DE TOTS ELS CLIENTS I UPDATA LA TAULA ME7
--  APART DEL CONSUM MIG DE TOTS ELS CLIENTS, EL NOMBRE DE CLIENTS QUE HI HA
--  SEPARATS PER TIPUS DE CLIENT I CONSUMS TOTALS TAMB SEPARATS PER TIPUS (POT SER 
--  TIL EN UN FUTUR PER ESTADSTIQUES, ETC.)
-- 
--  CADA CLIENT POT TENIR MS D'UN COMPTADOR CONTRACTAT, PER TANT, CADA CLIENT
--  T UNA SUMA DE CONSUMS.
--  EL CONSUM MIG SER LA SUMA DE CONSUMS DIVIDIT ENTRE ELS DIFERENTS CLIENTS 
--
--  Tant si hi ha errors com si insertem el registre a la taula, s'afegeix a la 
--  TAULALOG el resultat de la operaci.
--    
--  ENTRADA : NO HI HA PARMETRES D'ENTRADA.
--              
--   SORTIDA : RSP indicant si ha anat correcte o si ha hagut errors.
--          
--   RSP = OK : S'inserta registre a la taula ME6.
--   RSP = ERROR + motiu, si hi ha algn error.
--
--   Motius Error :
--      - Altres.
--      
--
--******************************************************************************/


IS
	-- variable error
        e_camps_nuls EXCEPTION;
       
        -- variables insert taulaLOG
        nomProcediment taulaLog.procExecutat%TYPE := 'PR_ACTUALITZAR_ME7';
	paramEntrada taulaLog.paramEntrada%TYPE := 'NO REP PARMETRES';
	paramSortida taulaLog.paramSortida%TYPE := 'RSP';
 
        -- variables pels comptadors varis
        cont number := 0;
        numElements number :=0;
        contClientPersona number:= 0;
        contClientEmpresa number := 0;
        contConsumPersona number(12,1) :=0;
        contConsumEmpresa number (12,1) :=0;
       
        nClients number(10);
        cMig number (12,1) :=0;
        
        -- variables de cursor
        c_idClient CLIENT.idClient%TYPE;
        c_tipusClient CLIENT.tipusClient%TYPE;
        c_SumConsumAbsolut COMPTADOR.consumAbsolut%TYPE;
              
        -- DEFINIM EL CURSOR QUE SERVIR PER CALCULAR EL RESULTAT
        -- PER CADA CLIENT  ES CALCULA LA SUMA
        -- DELS CONSUMS ABSOLUTS DELS COMPTADORS QUE T CONTRACTATS.
        -- CADA REGISTRE TINDR CLIENT I  SUMA DELS SEUS CONSUMS
        
      CURSOR cur_ME7 is
      SELECT CLIENT.IDCLIENT, CLIENT.TIPUSCLIENT, SUM(COMPTADOR.CONSUMABSOLUT)
        FROM CLIENT INNER JOIN CONTRACTE INNER JOIN COMPTADOR
        ON COMPTADOR.IDCOMPTADOR = CONTRACTE.IDCOMPTADOR
        ON CONTRACTE.IDCLIENT = CLIENT.IDCLIENT
        AND CLIENT.DATABAIXA IS NULL
        GROUP BY CLIENT.IDCLIENT, CLIENT.TIPUSCLIENT
        ORDER BY CLIENT.IDCLIENT;
      
      
BEGIN
     
           
     OPEN cur_ME7;
   
     FETCH cur_ME7 INTO c_idClient, c_tipusClient, c_SumConsumAbsolut;
    
            IF cur_ME7%NOTFOUND 
              THEN DBMS_OUTPUT.PUT_LINE('NO HI HA REGISTRES PER M7');
            ELSE 
               WHILE  cur_ME7%FOUND  loop
               -- PER CADA CLIENT, COMPTEM ELS QUE SN D'UN TIPUS O D'ALTRE
               -- I ELS SEUS CONSUMS
                IF c_tipusClient = 'E' THEN
                    contClientEmpresa := contClientEmpresa +1;
                    contConsumEmpresa := contConsumEmpresa + c_SumConsumAbsolut;
                ELSIF c_tipusClient = 'P' THEN
                    contClientPersona := contClientPersona +1;
                    contConsumPersona := contConsumPersona + c_SumConsumAbsolut;
                END IF;
   
             numElements := numElements +1;
             FETCH cur_ME7 INTO c_idClient, c_tipusClient, c_SumConsumAbsolut;
             END LOOP;
      CLOSE cur_ME7;  
    
           END IF;
           
   -- UPDATEM O INSERTEM A LA TAULA ME7
   nClients := contClientEmpresa + contClientPersona;
   cMig := (contConsumPersona + contConsumEmpresa) / numElements;
   
   --  MIREM SI HI HA REGISTRES A ME7 PER INSERTAR O UPDATAR
   --  noms hi ha un registre amb clau IDME7=1.
   SELECT COUNT(*) INTO cont FROM ME7;
   IF cont = 0 THEN
      INSERT INTO ME7 VALUES (1,nClients,contClientPersona, contClientEmpresa, 
      (contConsumPersona + contConsumEmpresa), contConsumPersona, contConsumEmpresa, cMig);
    ELSE UPDATE ME7 SET   ME7.nombreClients = nClients,
                        ME7.nombrePersones = contClientPersona,
                        ME7.nombreEmpreses = contClientEmpresa,
                        ME7.consumTotal = contConsumPersona + contConsumEmpresa,
                        ME7.consumPersones = contConsumPersona,
                        ME7.consumEmpreses = contConsumEmpresa,
                        ME7.consumMig = cMig
                      WHERE IDME7 = 1;
                      
    END IF;
   
   
   COMMIT;  
   
   
   RSP := 'OK';
   PR_INSERT_LOG(nomProcediment,paramEntrada, paramSortida, RSP,  sysdate);
   
   
EXCEPTION

	WHEN STORAGE_ERROR THEN
		RSP := 'ERROR: ERROR AL EMMAGATZEMAR';
		PR_INSERT_LOG(nomProcediment,paramEntrada, paramSortida, RSP,  sysdate);	
		ROLLBACK;
                
      
	WHEN OTHERS THEN
		RSP := 'ERROR: ERROR SENSE TRACTAR A P_ACTUALITZAR_ME6 - '||SQLCODE||'-'||SQLERRM;
		PR_INSERT_LOG( nomProcediment,paramEntrada, paramSortida, RSP, sysdate);	
		ROLLBACK;
	
END;
/