--/*****************************************************************************
--  PROCEDIMENT:  PR_INSERT_LOG
--    
--  Resistra al log les crides als procediments i la seva  finalitzaci 
--  (OK, ERROR). A ms a ms es guarden els parmetres i el timestamp.
-- 
--  ENTRADA : p_procExecutat (varchar2), p_paramEntrada(varchar2),
--            p_paramSortida(varchar2), p_RSP (varchar2), p_datahora (timestamp)
--  SORTIDA : MISSATGES indicant si ha anat correcte o si ha hagut errors.
--
--   paramSortida s  el nom dels parmetres de sortida, en aquest cas, noms
--   hi ha un (RSP).
--   RSP s la resposta que dona els procediments. OK o ERROR + MOTIU.
--   idLog s'agafa de la seva seqncia.
--
--    Motius errors tractats:
--        - camps nuls.

--*****************************************************************************/

CREATE OR REPLACE
PROCEDURE PR_INSERT_LOG (



p_procExecutat IN taulaLog.procExecutat%TYPE,
p_paramEntrada IN taulaLog.paramEntrada%TYPE,
p_paramSortida IN taulaLog.paramSortida%TYPE,
p_RSP IN taulaLog.RSP%TYPE,
p_dataHora IN taulaLog.dataHora%TYPE
  ) 
          
IS
    -- variable error
    falta_valor_camp	EXCEPTION;
       
BEGIN
    
    -- verifiquem que cap parmetre t nuls
    IF ( p_procExecutat IS NULL OR 
       	p_paramEntrada IS NULL OR p_paramSortida IS NULL OR 
        p_dataHora is NULL OR P_rsp IS NULL) 
    
     THEN RAISE falta_valor_camp;
     
    -- si no hi ha nuls, insertem a la taulaLOG
    ELSE
      INSERT INTO TAULALOG 
      VALUES (null,p_procExecutat, p_paramEntrada, p_paramSortida, p_RSP, 
              p_dataHora);
      COMMIT;
    END IF;

EXCEPTION
  WHEN falta_valor_camp THEN
  DBMS_OUTPUT.PUT_LINE('ERROR : CAMPS NULS AL INSERTAR A LOG');
  DBMS_OUTPUT.PUT_LINE('PARMETRES. PROCEDIMENT = '||p_PROCEXECUTAT
        ||'. ENTRADA = '||p_paramentrada||'. SORTIDA = '||P_paramsortida||
        '. RSP = '||P_RSP|| '. DATA I HORA EXECUCI = '|| p_dataHora);
  ROLLBACK;
	
  WHEN STORAGE_ERROR THEN
      DBMS_OUTPUT.PUT_LINE('ERROR: ERROR AL GUARDAR EN EL LOG. IDLOG '
                           || ' - '||SQLCODE||'-'||SQLERRM);
      DBMS_OUTPUT.PUT_LINE('PARMETRES. PROCEDIMENT = '||p_PROCEXECUTAT
        ||'. ENTRADA = '||p_paramentrada||'. SORTIDA = '||P_paramsortida||
        '. RSP = '||P_RSP|| '. DATA I HORA EXECUCI = '|| p_dataHora);
      ROLLBACK;

  WHEN OTHERS THEN
   DBMS_OUTPUT.PUT_LINE('ERROR : NO ES POT INSERTAR A LOG. '||SQLCODE||'-'
                        ||SQLERRM);
   DBMS_OUTPUT.PUT_LINE('PARMETRES. PROCEDIMENT = '||p_PROCEXECUTAT
        ||'. ENTRADA = '||p_paramentrada||'. SORTIDA = '||P_paramsortida||
        '. RSP = '||P_RSP|| '. DATA I HORA EXECUCI = '|| p_dataHora);
  ROLLBACK;
	
END;
/