SET SERVEROUTPUT ON
SET LINESIZE 120

/*********************************************************************
	AQUEST SCRIPT REALITZA LES PROVES DELS PROCEDIMENTS D'ALTES
	EN EL ORDRE SEGENT:

	- ALTA DE MODEL DE COMPTADOR
	- ALTA COMPTADOR
	- ALTA CLIENT
	- ALTA CONTRACTE
	- ALTA CENTRAL DISTRIBUCI
	- ALTA LNIA
	- ALTA CENTRAL PRODUCCI
	- ALTA CONNLINIA
	- ALTA CONNCOMPTADOR
	- ALTA LECTURA

 DESDE SQL*PLUS ENTRE CADASC, S'HA DE POLSAR UNA TECLA PER CONTINUAR

***********************************************************************/
PROMPT INICI LES PROVES DELS PROCEDIMENTS D''ALTA
PROMPT ******************************************
PROMPT

DECLARE
RSP VARCHAR2(300);
BEGIN

DBMS_OUTPUT.PUT_LINE('TEST : ALTA DE MODEL COMPTADOR JA EXISTENT');
DBMS_OUTPUT.PUT_LINE('INSTRUCCIO: PR_ALTA_MODELCOMPT (2,''FABRICANT2'',''MODEL2-1'',15.0,RSP);');
PR_ALTA_MODELCOMPT (2,'FABRICANT2','MODEL2-1',15.0,RSP);
DBMS_OUTPUT.PUT_LINE('RSP  ----> '||RSP);
DBMS_OUTPUT.PUT_LINE('');
DBMS_OUTPUT.PUT_LINE('==========================================================================');
DBMS_OUTPUT.PUT_LINE('');

DBMS_OUTPUT.PUT_LINE('TEST : ALTA DE MODEL COMPTADOR -  CORRECTE');
DBMS_OUTPUT.PUT_LINE('INSTRUCCIO: PR_ALTA_MODELCOMPT (8,''FABRICANT8'',''MODEL8-8'',25.0,RSP);');
PR_ALTA_MODELCOMPT (8,'FABRICANT8','MODEL8-8',25.0,RSP);
DBMS_OUTPUT.PUT_LINE('RSP  ----> '||RSP);
DBMS_OUTPUT.PUT_LINE('');
DBMS_OUTPUT.PUT_LINE('==========================================================================');
DBMS_OUTPUT.PUT_LINE('');


DBMS_OUTPUT.PUT_LINE('TEST : ALTA COMPTADOR JA EXISTENT');
DBMS_OUTPUT.PUT_LINE('INSTRUCCIO: PR_ALTA_COMPTADOR(15,3,''C/COMPTADOR15'',''08080'',''BARCELONA'',''ESPANYA'',0,0,1999,RSP);');
PR_ALTA_COMPTADOR(15,3,'C/COMPTADOR15','08080','BARCELONA','ESPANYA',0,0,1999,RSP);
DBMS_OUTPUT.PUT_LINE('RSP  ----> '||RSP);
DBMS_OUTPUT.PUT_LINE('');
DBMS_OUTPUT.PUT_LINE('==========================================================================');
DBMS_OUTPUT.PUT_LINE('');

DBMS_OUTPUT.PUT_LINE('TEST : ALTA COMPTADOR - NO EXISTEIX IDMODEL');
DBMS_OUTPUT.PUT_LINE('INSTRUCCIO: PR_ALTA_COMPTADOR(99,99,''C/COMPTADOR15'',''08080'',''BARCELONA'',''ESPANYA'',0,0,1999,RSP);');
PR_ALTA_COMPTADOR(99,99,'C/COMPTADOR15','08080','BARCELONA','ESPANYA',0,0,1999,RSP);
DBMS_OUTPUT.PUT_LINE('RSP  ----> '||RSP);
DBMS_OUTPUT.PUT_LINE('');
DBMS_OUTPUT.PUT_LINE('==========================================================================');
DBMS_OUTPUT.PUT_LINE('');


DBMS_OUTPUT.PUT_LINE('TEST : ALTA COMPTADOR - PARAMETRE CONSUM INCORRECTE (HA DE SER ZERO)');
DBMS_OUTPUT.PUT_LINE('INSTRUCCIO: PR_ALTA_COMPTADOR(99,3,''C/COMPTADOR15'',''08080'',''BARCELONA'',''ESPANYA'',-99,0,1999,RSP);');
PR_ALTA_COMPTADOR(99,3,'C/COMPTADOR15','08080','BARCELONA','ESPANYA',-99,0,1999,RSP);
DBMS_OUTPUT.PUT_LINE('RSP  ----> '||RSP);
DBMS_OUTPUT.PUT_LINE('');
DBMS_OUTPUT.PUT_LINE('==========================================================================');
DBMS_OUTPUT.PUT_LINE('');

DBMS_OUTPUT.PUT_LINE('TEST : ALTA COMPTADOR - PARAMETRES NULS');
DBMS_OUTPUT.PUT_LINE('INSTRUCCIO: PR_ALTA_COMPTADOR(99,3,''C/COMPTADOR15'',''08080'',''BARCELONA'',''ESPANYA'',0,NULL,1999,RSP);');
PR_ALTA_COMPTADOR(99,3,'C/COMPTADOR15','08080','BARCELONA','ESPANYA',0,NULL,1999,RSP);
DBMS_OUTPUT.PUT_LINE('RSP  ----> '||RSP);
DBMS_OUTPUT.PUT_LINE('');
DBMS_OUTPUT.PUT_LINE('==========================================================================');
DBMS_OUTPUT.PUT_LINE('');

DBMS_OUTPUT.PUT_LINE('TEST : ALTA COMPTADOR - ANY FABRICACIO INCORRECTE');
DBMS_OUTPUT.PUT_LINE('INSTRUCCIO: PR_ALTA_COMPTADOR(99,3,''C/COMPTADOR15'',''08080'',''BARCELONA'',''ESPANYA'',0,0,2020,RSP);');
PR_ALTA_COMPTADOR(99,3,'C/COMPTADOR15','08080','BARCELONA','ESPANYA',0,0,2020,RSP);
DBMS_OUTPUT.PUT_LINE('RSP  ----> '||RSP);
DBMS_OUTPUT.PUT_LINE('');
DBMS_OUTPUT.PUT_LINE('==========================================================================');
DBMS_OUTPUT.PUT_LINE('');

DBMS_OUTPUT.PUT_LINE('TEST : ALTA COMPTADOR - CORRECTE');
DBMS_OUTPUT.PUT_LINE('INSTRUCCIO: PR_ALTA_COMPTADOR(99,3,''C/COMPTADOR15'',''08080'',''BARCELONA'',''ESPANYA'',0,0,2001,RSP);');
PR_ALTA_COMPTADOR(99,3,'C/COMPTADOR15','08080','BARCELONA','ESPANYA',0,0,2001,RSP);
DBMS_OUTPUT.PUT_LINE('RSP  ----> '||RSP);
DBMS_OUTPUT.PUT_LINE('');
DBMS_OUTPUT.PUT_LINE('==========================================================================');
DBMS_OUTPUT.PUT_LINE('');


END;

/

PROMPT POLSAR UNA TECLA PER CONTINUAR...
PAUSE

---- PROVES CLIENTS

DECLARE
RSP VARCHAR2(300);
BEGIN
-- PRIMER ESBORRO EL CLIENT DE PROVA
DELETE FROM CLIENT WHERE CLIENT.IDCLIENT = 99;
DBMS_OUTPUT.PUT_LINE('TEST : ALTA DE CLIENTS - IDCLIENT REPETIT');
DBMS_OUTPUT.PUT_LINE('INSTRUCCIO: PR_ALTA_CLIENT(2,''57987488A'',''E'',''EMPRESAB'',NULL,NULL,''C/EMPRESA-B'',''08080'',
			''BARCELONA'',''ESPANYA'',''02/02/2002'',RSP);');
PR_ALTA_CLIENT(2,'57987488A','E','EMPRESAB',NULL,NULL,'C/EMPRESA-B','08080','BARCELONA','ESPANYA','02/02/2002',RSP);
DBMS_OUTPUT.PUT_LINE('RSP  ----> '||RSP);
DBMS_OUTPUT.PUT_LINE('');
DBMS_OUTPUT.PUT_LINE('==========================================================================');
DBMS_OUTPUT.PUT_LINE('');


DBMS_OUTPUT.PUT_LINE('TEST : ALTA DE CLIENTS - CAMPS NULS NO SUPORTATS (EXCEPTE COGNOMS)');
DBMS_OUTPUT.PUT_LINE('INSTRUCCIO: PR_ALTA_CLIENT(2,NULL,''E'',''EMPRESAB'',NULL,NULL,''C/EMPRESA-B'',''08080'',
			''BARCELONA'',''ESPANYA'',''02/02/2002'',RSP);');
PR_ALTA_CLIENT(2,NULL,'E','EMPRESAB',NULL,NULL,'C/EMPRESA-B','08080','BARCELONA','ESPANYA','02/02/2002',RSP);
DBMS_OUTPUT.PUT_LINE('RSP  ----> '||RSP);
DBMS_OUTPUT.PUT_LINE('');
DBMS_OUTPUT.PUT_LINE('==========================================================================');
DBMS_OUTPUT.PUT_LINE('');


DBMS_OUTPUT.PUT_LINE('TEST : ALTA DE CLIENTS - TIPUS INCORRECTE (HA DE SER ''E''MPRESA , ''P''ERSONA)');
DBMS_OUTPUT.PUT_LINE('INSTRUCCIO: PR_ALTA_CLIENT(99,''57987488A'',''K'',''EMPRESAB'',NULL,NULL,''C/EMPRESA-B'',''08080'',
			''BARCELONA'',''ESPANYA'',''02/02/2002'',RSP);');
PR_ALTA_CLIENT(99,'57987488A','K','EMPRESAB',NULL,NULL,'C/EMPRESA-B','08080','BARCELONA','ESPANYA','02/02/2002',RSP);
DBMS_OUTPUT.PUT_LINE('RSP  ----> '||RSP);
DBMS_OUTPUT.PUT_LINE('');
DBMS_OUTPUT.PUT_LINE('==========================================================================');
DBMS_OUTPUT.PUT_LINE('');


DBMS_OUTPUT.PUT_LINE('TEST : ALTA DE CLIENTS - SI ES EMPRESA NO S''HA D''OMPLIR ELS PARAMETRES COGNOMS');
DBMS_OUTPUT.PUT_LINE('INSTRUCCIO: PR_ALTA_CLIENT(99,''57987488A'',''E'',''EMPRESAB'',''LOPEZ'',NULL,''C/EMPRESA-B'',''08080'',''BARCELONA'',''ESPANYA'',''02/02/2002'',RSP);');
PR_ALTA_CLIENT(99,'57987488A','E','EMPRESAB','LOPEZ',NULL,'C/EMPRESA-B','08080','BARCELONA','ESPANYA','02/02/2002',RSP);
DBMS_OUTPUT.PUT_LINE('RSP  ----> '||RSP);
DBMS_OUTPUT.PUT_LINE('');
DBMS_OUTPUT.PUT_LINE('==========================================================================');
DBMS_OUTPUT.PUT_LINE('');


DBMS_OUTPUT.PUT_LINE('TEST : ALTA DE CLIENTS - SI ES PERSONA S''HA D''OMPLIR ALMENYS COGNOM1');
DBMS_OUTPUT.PUT_LINE('INSTRUCCIO: PR_ALTA_CLIENT(99,''45755213V'',''P'',''NOMPERSONA-C'',NULL,''COGNOM2-C'',''C/PERSONA-C'',''48008'',''BILBAO'',''ESPANYA'',''02/02/2001'',RSP);');
PR_ALTA_CLIENT(99,'45755213V','P','NOMPERSONA-C',NULL,'COGNOM2-C','C/PERSONA-C','48008','BILBAO','ESPANYA','02/02/2001',RSP);
DBMS_OUTPUT.PUT_LINE('RSP  ----> '||RSP);
DBMS_OUTPUT.PUT_LINE('');
DBMS_OUTPUT.PUT_LINE('==========================================================================');
DBMS_OUTPUT.PUT_LINE('');


DBMS_OUTPUT.PUT_LINE('TEST : ALTA DE CLIENTS - DATA ANTIGUITAT (02/02/2015) SUPERIOR A LA ACTUAL');
DBMS_OUTPUT.PUT_LINE('INSTRUCCIO: PR_ALTA_CLIENT(99,''45755213V'',''P'',''NOMPERSONA-C'',''COGNOM1-C'',''COGNOM2-C'',''C/PERSONA-C'',''48008'',''BILBAO'',''ESPANYA'',''02/02/2015'',RSP);');
PR_ALTA_CLIENT(99,'45755213V','P','NOMPERSONA-C','COGNOM1-C','COGNOM2-C','C/PERSONA-C','48008','BILBAO','ESPANYA','02/02/2015',RSP);
DBMS_OUTPUT.PUT_LINE('RSP  ----> '||RSP);
DBMS_OUTPUT.PUT_LINE('');
DBMS_OUTPUT.PUT_LINE('==========================================================================');
DBMS_OUTPUT.PUT_LINE('');


DBMS_OUTPUT.PUT_LINE('TEST : ALTA DE CLIENTS - CORRECTE');
--ABANS HO ESBORRO 
DELETE FROM CLIENT WHERE CLIENt.idClient = 99;
DELETE FROM CLIENT WHERE CLIENt.idClient = 100;
DBMS_OUTPUT.PUT_LINE('INSTRUCCIO: PR_ALTA_CLIENT(99,''87654321A'',''E'',''EMPRESAZ'',NULL,NULL,''C/EMPRESA-Z'',''08080'',''BARCELONA'',''ESPANYA'',''02/02/1999'',RSP);');

PR_ALTA_CLIENT(99,'87654321A','E','EMPRESAZ',NULL,NULL,'C/EMPRESA-Z','08080','BARCELONA','ESPANYA','02/02/1999',RSP);
DBMS_OUTPUT.PUT_LINE('RSP  ----> '||RSP);
DBMS_OUTPUT.PUT_LINE('');
DBMS_OUTPUT.PUT_LINE('==========================================================================');
DBMS_OUTPUT.PUT_LINE('');



DBMS_OUTPUT.PUT_LINE('TEST : ALTA DE CLIENTS - CORRECTE - INFORMANT QUE PER AQUELL NIF HI HA MES D''UN IDCLIENT');
DBMS_OUTPUT.PUT_LINE(' (AQUEST SUPOSIT POT PASSAR, JA QUE PER EXEMPLE UNA EMPRESA, POT TENIR DELEGACIONS ');
DBMS_OUTPUT.PUT_LINE('  EN DIFERENTS PROVINCIES I CADA DELEGACIO FARIA UN ROL CLIENT DIFERENT) ');
DBMS_OUTPUT.PUT_LINE('INSTRUCCIO: PR_ALTA_CLIENT(100,''87654321A'',''E'',''EMPRESAZ'',NULL,NULL,''C/EMPRESA-Z'',''08080'',''BARCELONA'',''ESPANYA'',''02/02/1999'',RSP);');

PR_ALTA_CLIENT(100,'87654321A','E','EMPRESAZ',NULL,NULL,'C/EMPRESA-Z','08080','BARCELONA','ESPANYA','02/02/1999',RSP);
DBMS_OUTPUT.PUT_LINE('RSP  ----> '||RSP);
DBMS_OUTPUT.PUT_LINE('');
DBMS_OUTPUT.PUT_LINE('==========================================================================');
DBMS_OUTPUT.PUT_LINE('');


END;

/

PROMPT POLSAR UNA TECLA PER CONTINUAR..
PAUSE


DECLARE
RSP VARCHAR2(300);
BEGIN

DBMS_OUTPUT.PUT_LINE('TEST : ALTA DE CONTRACTE - CAMPS NULS');
DBMS_OUTPUT.PUT_LINE('INSTRUCCIO: PR_ALTA_CONTRACTE(99,17,NULL,105,''05/05/2003'',RSP);');

PR_ALTA_CONTRACTE(99,17,NULL,105,'05/05/2003',RSP);
DBMS_OUTPUT.PUT_LINE('RSP  ----> '||RSP);
DBMS_OUTPUT.PUT_LINE('');
DBMS_OUTPUT.PUT_LINE('==========================================================================');
DBMS_OUTPUT.PUT_LINE('');


DBMS_OUTPUT.PUT_LINE('TEST : ALTA DE CONTRACTE - IDCOMPTADOR NO EXISTEIX');
DBMS_OUTPUT.PUT_LINE('INSTRUCCIO: PR_ALTA_CONTRACTE(99,999,7,105,''05/05/2003'',RSP);');

PR_ALTA_CONTRACTE(99,999,7,105,'05/05/2003',RSP);
DBMS_OUTPUT.PUT_LINE('RSP  ----> '||RSP);
DBMS_OUTPUT.PUT_LINE('');
DBMS_OUTPUT.PUT_LINE('==========================================================================');
DBMS_OUTPUT.PUT_LINE('');


DBMS_OUTPUT.PUT_LINE('TEST : ALTA DE CONTRACTE - IDCLIENT NO EXISTEIX');
DBMS_OUTPUT.PUT_LINE('INSTRUCCIO: PR_ALTA_CONTRACTE(99,17,999,105,''05/05/2003'',RSP);');

PR_ALTA_CONTRACTE(99,17,999,105,'05/05/2003',RSP);
DBMS_OUTPUT.PUT_LINE('RSP  ----> '||RSP);
DBMS_OUTPUT.PUT_LINE('');
DBMS_OUTPUT.PUT_LINE('==========================================================================');
DBMS_OUTPUT.PUT_LINE('');


DBMS_OUTPUT.PUT_LINE('TEST : ALTA DE CONTRACTE - KW CONTRACTATS NO SUPORTATS PEL MODEL DE COMPTADOR');
DBMS_OUTPUT.PUT_LINE('INSTRUCCIO: PR_ALTA_CONTRACTE(99,17,7,900,''05/05/2003'',RSP);');

PR_ALTA_CONTRACTE(99,17,7,900,'05/05/2003',RSP);
DBMS_OUTPUT.PUT_LINE('RSP  ----> '||RSP);
DBMS_OUTPUT.PUT_LINE('');
DBMS_OUTPUT.PUT_LINE('==========================================================================');
DBMS_OUTPUT.PUT_LINE('');

DBMS_OUTPUT.PUT_LINE('TEST : ALTA DE CONTRACTE - DATA ALTA INCORRECTA');
DBMS_OUTPUT.PUT_LINE('INSTRUCCIO: PR_ALTA_CONTRACTE(99,17,7,105,''05/05/2015'',RSP);');

PR_ALTA_CONTRACTE(99,17,7,105,'05/05/2015',RSP);
DBMS_OUTPUT.PUT_LINE('RSP  ----> '||RSP);
DBMS_OUTPUT.PUT_LINE('');
DBMS_OUTPUT.PUT_LINE('==========================================================================');
DBMS_OUTPUT.PUT_LINE('');


DBMS_OUTPUT.PUT_LINE('TEST : ALTA DE CONTRACTE - COMPTADOR AMB CONTRACTE EN VIGENCIA');
DBMS_OUTPUT.PUT_LINE('INSTRUCCIO: PR_ALTA_CONTRACTE(99,17,7,105,''05/05/2003'',RSP);');

PR_ALTA_CONTRACTE(99,17,7,105,'05/05/2003',RSP);
DBMS_OUTPUT.PUT_LINE('RSP  ----> '||RSP);
DBMS_OUTPUT.PUT_LINE('');
DBMS_OUTPUT.PUT_LINE('==========================================================================');
DBMS_OUTPUT.PUT_LINE('');



DBMS_OUTPUT.PUT_LINE('TEST : ALTA DE CONTRACTE - CORRECTE');
--abans ho esborro
DELETE CONTRACTE WHERE CONTRACTE.codi = 99;

DBMS_OUTPUT.PUT_LINE('INSTRUCCIO: PR_ALTA_CONTRACTE(99,99,7,4,''05/05/1999'',RSP);');

PR_ALTA_CONTRACTE(99,99,7,4,'05/05/1999',RSP);
DBMS_OUTPUT.PUT_LINE('RSP  ----> '||RSP);
DBMS_OUTPUT.PUT_LINE('');
DBMS_OUTPUT.PUT_LINE('==========================================================================');
DBMS_OUTPUT.PUT_LINE('');


END;
/


PROMPT POLSAR UNA TECLA PER CONTINUAR..
PAUSE


------- PROVES ALTA CENTRAL DISTRIBUCIO

DECLARE
RSP VARCHAR2(300);
BEGIN
-- ESBORRO LA IDCDIST DE PROVA
DELETE CENTRALDIST WHERE CENTRALDIST.IDCDIST = 99;

DBMS_OUTPUT.PUT_LINE('TEST : ALTA DE CENTRAL DISTRIBUCIO - CENTRAL JA EXISTEIX');
DBMS_OUTPUT.PUT_LINE('INSTRUCCIO: PR_ALTA_CENTRALDIST(13,''C/CENTRALDISTN'',''30006'',''MURCIA'',''ESPANYA'',750,''01/01/2000'',RSP);');

PR_ALTA_CENTRALDIST(13,'C/CENTRALDISTN','30006','MURCIA','ESPANYA',750,'01/01/2000',RSP);
DBMS_OUTPUT.PUT_LINE('RSP  ----> '||RSP);
DBMS_OUTPUT.PUT_LINE('');
DBMS_OUTPUT.PUT_LINE('==========================================================================');
DBMS_OUTPUT.PUT_LINE('');



DBMS_OUTPUT.PUT_LINE('TEST : ALTA DE CENTRAL DISTRIBUCIO - CAMPS NULS');
DBMS_OUTPUT.PUT_LINE('INSTRUCCIO: PR_ALTA_CENTRALDIST(99,NULL,''30006'',''MURCIA'',''ESPANYA'',750,''01/01/2000'',RSP);');

PR_ALTA_CENTRALDIST(99,NULL,'30006','MURCIA','ESPANYA',750,'01/01/2000',RSP);
DBMS_OUTPUT.PUT_LINE('RSP  ----> '||RSP);
DBMS_OUTPUT.PUT_LINE('');
DBMS_OUTPUT.PUT_LINE('==========================================================================');
DBMS_OUTPUT.PUT_LINE('');



DBMS_OUTPUT.PUT_LINE('TEST : ALTA DE CENTRAL DISTRIBUCIO - DATA FUNCIONAMENT ERRONIA');
DBMS_OUTPUT.PUT_LINE('INSTRUCCIO: PR_ALTA_CENTRALDIST(99,''C/CENTRALDISTN'',''30006'',''MURCIA'',''ESPANYA'',750,''01/01/2015'',RSP);');

PR_ALTA_CENTRALDIST(99,'C/CENTRALDISTN','30006','MURCIA','ESPANYA',750,'01/01/2015',RSP);
DBMS_OUTPUT.PUT_LINE('RSP  ----> '||RSP);
DBMS_OUTPUT.PUT_LINE('');
DBMS_OUTPUT.PUT_LINE('==========================================================================');
DBMS_OUTPUT.PUT_LINE('');


DBMS_OUTPUT.PUT_LINE('TEST : ALTA DE CENTRAL DISTRIBUCIO - MAX KWH SUPORTATS HAN DE SER POSITIUS');
DBMS_OUTPUT.PUT_LINE('INSTRUCCIO: PR_ALTA_CENTRALDIST(99,''C/CENTRALDISTN'',''30006'',''MURCIA'',''ESPANYA'',-1000,''01/01/2000'',RSP);');

PR_ALTA_CENTRALDIST(99,'C/CENTRALDISTN','30006','MURCIA','ESPANYA',-1000,'01/01/2000',RSP);
DBMS_OUTPUT.PUT_LINE('RSP  ----> '||RSP);
DBMS_OUTPUT.PUT_LINE('');
DBMS_OUTPUT.PUT_LINE('==========================================================================');
DBMS_OUTPUT.PUT_LINE('');


DBMS_OUTPUT.PUT_LINE('TEST : ALTA DE CENTRAL DISTRIBUCIO - ADRECA C DIST HA DE SER UNIQUE');
DBMS_OUTPUT.PUT_LINE('INSTRUCCIO: PR_ALTA_CENTRALDIST(99,''C/CENTRALDISTN'',''30006'',''MURCIA'',''ESPANYA'',750,''01/01/2000'',RSP);');

PR_ALTA_CENTRALDIST(99,'C/CENTRALDISTN','30006','MURCIA','ESPANYA',750,'01/01/2000',RSP);
DBMS_OUTPUT.PUT_LINE('RSP  ----> '||RSP);
DBMS_OUTPUT.PUT_LINE('');
DBMS_OUTPUT.PUT_LINE('==========================================================================');
DBMS_OUTPUT.PUT_LINE('');



DBMS_OUTPUT.PUT_LINE('TEST : ALTA DE CENTRAL DISTRIBUCIO - CORRECTE');
DBMS_OUTPUT.PUT_LINE('INSTRUCCIO: PR_ALTA_CENTRALDIST(99,''C/CENTRALDISTZ'',''30006'',''MURCIA'',''ESPANYA'',750,''01/01/2000'',RSP);');

PR_ALTA_CENTRALDIST(99,'C/CENTRALDISTZ','30006','MURCIA','ESPANYA',750,'01/01/2000',RSP);
DBMS_OUTPUT.PUT_LINE('RSP  ----> '||RSP);
DBMS_OUTPUT.PUT_LINE('');
DBMS_OUTPUT.PUT_LINE('==========================================================================');
DBMS_OUTPUT.PUT_LINE('');



END;
/


PROMPT POLSAR UNA TECLA PER CONTINUAR..
PAUSE



------ PROVES ALTA LINIA
DECLARE
RSP VARCHAR2(300);
BEGIN
-- ESBORRO LA LINIA DE PROVA
DELETE LINIA WHERE LINIA.IDLINIA = 99;

DBMS_OUTPUT.PUT_LINE('TEST : ALTA LINIA - VALORS NULS PARAMETRES ENTRADA');
DBMS_OUTPUT.PUT_LINE('INSTRUCCIO: PR_ALTA_LINIA(99,NULL,RSP);');

PR_ALTA_LINIA(99,NULL,RSP);
DBMS_OUTPUT.PUT_LINE('RSP  ----> '||RSP);
DBMS_OUTPUT.PUT_LINE('');
DBMS_OUTPUT.PUT_LINE('==========================================================================');
DBMS_OUTPUT.PUT_LINE('');


DBMS_OUTPUT.PUT_LINE('TEST : ALTA LINIA - MAX KWH AMB VALOR NEGATIU');
DBMS_OUTPUT.PUT_LINE('INSTRUCCIO: PR_ALTA_LINIA(99,-1000,RSP);');

PR_ALTA_LINIA(99,-1000,RSP);
DBMS_OUTPUT.PUT_LINE('RSP  ----> '||RSP);
DBMS_OUTPUT.PUT_LINE('');
DBMS_OUTPUT.PUT_LINE('==========================================================================');
DBMS_OUTPUT.PUT_LINE('');



DBMS_OUTPUT.PUT_LINE('TEST : ALTA LINIA - CORRECTE ');
DBMS_OUTPUT.PUT_LINE('INSTRUCCIO: PR_ALTA_LINIA(99,1000,RSP);');

PR_ALTA_LINIA(99,1000,RSP);
DBMS_OUTPUT.PUT_LINE('RSP  ----> '||RSP);

DBMS_OUTPUT.PUT_LINE('');
DBMS_OUTPUT.PUT_LINE('==========================================================================');
DBMS_OUTPUT.PUT_LINE('');


END;
/


PROMPT POLSAR UNA TECLA PER CONTINUAR..
PAUSE


--- PROVES ALTA CENTRAL PRODUCCIO

DECLARE
RSP VARCHAR2(300);
BEGIN
-- ESBORRO LA CENTRAL PRODUCCIO DE PROVA
DELETE CPSOLAR WHERE CPSOLAR.IDCPROD = 99;
DELETE CENTRALPROD WHERE CENTRALPROD.IDCPROD = 99;

DBMS_OUTPUT.PUT_LINE('TEST : ALTA CENTRAL PRODUCCIO - PARAMETRES NULS ');

DBMS_OUTPUT.PUT_LINE('INSTRUCCIO: PR_ALTA_CENTRALPROD(99,''C/CENTRALPRODC'',''28000'',''MADRID'',''ESPANYA'',NULL,''01/01/1997'',''01/01/1998'',''SOLAR'',75,RSP);');

PR_ALTA_CENTRALPROD(99,'C/CENTRALPRODC','28000','MADRID','ESPANYA',NULL,'01/01/1997','01/01/1998','SOLAR',75,RSP);
DBMS_OUTPUT.PUT_LINE('RSP  ----> '||RSP);
DBMS_OUTPUT.PUT_LINE('');
DBMS_OUTPUT.PUT_LINE('==========================================================================');
DBMS_OUTPUT.PUT_LINE('');


DBMS_OUTPUT.PUT_LINE('TEST : ALTA CENTRAL PRODUCCIO - MAX KWH HA DE SER POSITIU ');
DBMS_OUTPUT.PUT_LINE('INSTRUCCIO: PR_ALTA_CENTRALPROD(99,''C/CENTRALPRODC'',''28000'',''MADRID'',''ESPANYA'',-1500,''01/01/1997'',''01/01/1998'',''SOLAR'',75,RSP);');
PR_ALTA_CENTRALPROD(99,'C/CENTRALPRODC','28000','MADRID','ESPANYA',-1500,'01/01/1997','01/01/1998','SOLAR',75,RSP);
DBMS_OUTPUT.PUT_LINE('RSP  ----> '||RSP);
DBMS_OUTPUT.PUT_LINE('');
DBMS_OUTPUT.PUT_LINE('==========================================================================');
DBMS_OUTPUT.PUT_LINE('');

DBMS_OUTPUT.PUT_LINE('TEST : ALTA CENTRAL PRODUCCIO - DATA FUNCIONAMENT NO HA DE SER  MAJOR A L''ACTUAL ');
DBMS_OUTPUT.PUT_LINE('INSTRUCCIO: PR_ALTA_CENTRALPROD(99,''C/CENTRALPRODC'',''28000'',''MADRID'',''ESPANYA'',1500,''01/01/1997'',''01/01/2020'',''SOLAR'',75,RSP);');

PR_ALTA_CENTRALPROD(99,'C/CENTRALPRODC','28000','MADRID','ESPANYA',1500,'01/01/1997','01/01/2020','SOLAR',75,RSP);
DBMS_OUTPUT.PUT_LINE('RSP  ----> '||RSP);
DBMS_OUTPUT.PUT_LINE('');
DBMS_OUTPUT.PUT_LINE('==========================================================================');
DBMS_OUTPUT.PUT_LINE('');


DBMS_OUTPUT.PUT_LINE('TEST : ALTA CENTRAL PRODUCCIO - DATA DARRERA INSPECCIO NO HA DE SER MAJOR A L''ACTUAL ');
DBMS_OUTPUT.PUT_LINE('INSTRUCCIO: PR_ALTA_CENTRALPROD(99,''C/CENTRALPRODC'',''28000'',''MADRID'',''ESPANYA'',1500,''01/01/2020'',''01/01/1998'',''SOLAR'',75,RSP);');

PR_ALTA_CENTRALPROD(99,'C/CENTRALPRODC','28000','MADRID','ESPANYA',1500,'01/01/2020','01/01/1998','SOLAR',75,RSP);
DBMS_OUTPUT.PUT_LINE('RSP  ----> '||RSP);
DBMS_OUTPUT.PUT_LINE('');
DBMS_OUTPUT.PUT_LINE('==========================================================================');
DBMS_OUTPUT.PUT_LINE('');


DBMS_OUTPUT.PUT_LINE('TEST : ALTA CENTRAL PRODUCCIO - TIPUS DE C. PRODUCC. ERRONI ');
DBMS_OUTPUT.PUT_LINE('INSTRUCCIO: PR_ALTA_CENTRALPROD(99,''C/CENTRALPRODC'',''28000'',''MADRID'',''ESPANYA'',1500,''01/01/1997'',''01/01/1998'',''tTtTtT'',75,RSP);');

PR_ALTA_CENTRALPROD(99,'C/CENTRALPRODC','28000','MADRID','ESPANYA',1500,'01/01/1997','01/01/1998','TtTtT',75,RSP);
DBMS_OUTPUT.PUT_LINE('RSP  ----> '||RSP);
DBMS_OUTPUT.PUT_LINE('');
DBMS_OUTPUT.PUT_LINE('==========================================================================');
DBMS_OUTPUT.PUT_LINE('');


DBMS_OUTPUT.PUT_LINE('TEST : ALTA CENTRAL PRODUCCIO - CORRECTE ');
DBMS_OUTPUT.PUT_LINE('INSTRUCCIO: PR_ALTA_CENTRALPROD(99,''C/CENTRALPRODC'',''28000'',''MADRID'',''ESPANYA'',1500,''01/01/1997'',''01/01/1998'',''SOLAR'',75,RSP);');

PR_ALTA_CENTRALPROD(99,'C/CENTRALPRODC','28000','MADRID','ESPANYA',1500,'01/01/1997','01/01/1998','SOLAR',75,RSP);
DBMS_OUTPUT.PUT_LINE('RSP  ----> '||RSP);
DBMS_OUTPUT.PUT_LINE('');
DBMS_OUTPUT.PUT_LINE('==========================================================================');
DBMS_OUTPUT.PUT_LINE('');


END;
/

PROMPT POLSAR UNA TECLA PER CONTINUAR..
PAUSE


--- PROVES ALTA CONNLINIA
DECLARE
RSP VARCHAR2(300);
BEGIN
-- ESBORRO LA CONNLINIA DE PROVA
DELETE CONNLINIA WHERE IDCDIST = 99 AND IDLINIA = 99 AND IDCPROD =99;

DBMS_OUTPUT.PUT_LINE('TEST : ALTA CONNLINIA  - VALORS NULS ');
DBMS_OUTPUT.PUT_LINE('INSTRUCCIO: PR_ALTA_CONNLINIA(99,99,99,''P'',NULL,RSP);');

PR_ALTA_CONNLINIA(99,99,99,'P',NULL,RSP);
DBMS_OUTPUT.PUT_LINE('RSP  ----> '||RSP);
DBMS_OUTPUT.PUT_LINE('');
DBMS_OUTPUT.PUT_LINE('==========================================================================');
DBMS_OUTPUT.PUT_LINE('');


DBMS_OUTPUT.PUT_LINE('TEST : ALTA CONNLINIA  -  C.DIST NO EXISTEIX ');
DBMS_OUTPUT.PUT_LINE('INSTRUCCIO: PR_ALTA_CONNLINIA(8888,99,99,''P'',1,RSP);');

PR_ALTA_CONNLINIA(8888,99,99,'P',1,RSP);
DBMS_OUTPUT.PUT_LINE('RSP  ----> '||RSP);
DBMS_OUTPUT.PUT_LINE('');
DBMS_OUTPUT.PUT_LINE('==========================================================================');
DBMS_OUTPUT.PUT_LINE('');


DBMS_OUTPUT.PUT_LINE('TEST : ALTA CONNLINIA  -  LINIA NO EXISTEIX ');
DBMS_OUTPUT.PUT_LINE('INSTRUCCIO: PR_ALTA_CONNLINIA(99,8888,99,''P'',1,RSP);');

PR_ALTA_CONNLINIA(99,8888,99,'P',1,RSP);
DBMS_OUTPUT.PUT_LINE('RSP  ----> '||RSP);
DBMS_OUTPUT.PUT_LINE('');
DBMS_OUTPUT.PUT_LINE('==========================================================================');
DBMS_OUTPUT.PUT_LINE('');

DBMS_OUTPUT.PUT_LINE('TEST : ALTA CONNLINIA  -  C. PROD NO EXISTEIX ');
DBMS_OUTPUT.PUT_LINE('INSTRUCCIO: PR_ALTA_CONNLINIA(99,99,8888,''P'',1,RSP);');

PR_ALTA_CONNLINIA(99,99,8888,'P',1,RSP);
DBMS_OUTPUT.PUT_LINE('RSP  ----> '||RSP);
DBMS_OUTPUT.PUT_LINE('');
DBMS_OUTPUT.PUT_LINE('==========================================================================');
DBMS_OUTPUT.PUT_LINE('');



DBMS_OUTPUT.PUT_LINE('TEST : ALTA CONNLINIA  -  ESTAT ERRONI ');
DBMS_OUTPUT.PUT_LINE('INSTRUCCIO: PR_ALTA_CONNLINIA(99,99,99,''P'',3,RSP);');


PR_ALTA_CONNLINIA(99,99,99,'P',3,RSP);
DBMS_OUTPUT.PUT_LINE('RSP  ----> '||RSP);
DBMS_OUTPUT.PUT_LINE('');
DBMS_OUTPUT.PUT_LINE('==========================================================================');
DBMS_OUTPUT.PUT_LINE('');



DBMS_OUTPUT.PUT_LINE('TEST : ALTA CONNLINIA  -  TIPUS ERRONI ');
DBMS_OUTPUT.PUT_LINE('INSTRUCCIO: PR_ALTA_CONNLINIA(99,99,99,''W'',1,RSP);');


PR_ALTA_CONNLINIA(99,99,99,'W',1,RSP);
DBMS_OUTPUT.PUT_LINE('RSP  ----> '||RSP);
DBMS_OUTPUT.PUT_LINE('');
DBMS_OUTPUT.PUT_LINE('==========================================================================');
DBMS_OUTPUT.PUT_LINE('');



DBMS_OUTPUT.PUT_LINE('TEST : ALTA CONNLINIA  -  JA EXISTEIX CONNLINIA ');
DBMS_OUTPUT.PUT_LINE('INSTRUCCIO: PR_ALTA_CONNLINIA(1,1,1,''P'',1,RSP);');


PR_ALTA_CONNLINIA(1,1,1,'P',1,RSP);
DBMS_OUTPUT.PUT_LINE('RSP  ----> '||RSP);
DBMS_OUTPUT.PUT_LINE('');
DBMS_OUTPUT.PUT_LINE('==========================================================================');
DBMS_OUTPUT.PUT_LINE('');


DBMS_OUTPUT.PUT_LINE('TEST : ALTA CONNLINIA  - IDCDIST-IDCPROD REPETIDA  ');
DBMS_OUTPUT.PUT_LINE('      (NO TE LOGICA SI VOLEM FER LA C. DISTRIBUCIO EN ALTA DISPONIBILITAT '); 
DBMS_OUTPUT.PUT_LINE('       REBI DE LA MATEIXA C. DE PRODUCCIO ENCARA QUE PASSI PER ALTRA LINIA)');
DBMS_OUTPUT.PUT_LINE('INSTRUCCIO: PR_ALTA_CONNLINIA(1,99,1,''P'',1,RSP);');

PR_ALTA_CONNLINIA(1,99,1,'P',1,RSP);
DBMS_OUTPUT.PUT_LINE('RSP  ----> '||RSP);
DBMS_OUTPUT.PUT_LINE('');
DBMS_OUTPUT.PUT_LINE('==========================================================================');
DBMS_OUTPUT.PUT_LINE('');


DBMS_OUTPUT.PUT_LINE('TEST : ALTA CONNLINIA  - C. DISTRIB. JA REP ENERGIA ');
DBMS_OUTPUT.PUT_LINE('(         EN EL MODEL, UNA C. DISTRIB. NOMES POT REBRE D''UNA CENTRAL DE PRODUCCIO, '); 
DBMS_OUTPUT.PUT_LINE('          UNA CONNEXIO HA DE SER ACTIVA I LA RESTA HAN DE ESTAR DESACTIVADES) ');
DBMS_OUTPUT.PUT_LINE('INSTRUCCIO: PR_ALTA_CONNLINIA(1,99,4,''P'',1,RSP);');

PR_ALTA_CONNLINIA(1,99,4,'P',1,RSP);
DBMS_OUTPUT.PUT_LINE('RSP  ----> '||RSP);
DBMS_OUTPUT.PUT_LINE('');
DBMS_OUTPUT.PUT_LINE('==========================================================================');
DBMS_OUTPUT.PUT_LINE('');

DBMS_OUTPUT.PUT_LINE('TEST : ALTA CONNLINIA  - C. DISTRIBUCIO JA TE UNA CONNEXIO PRINCIPAL ');
DBMS_OUTPUT.PUT_LINE('       (EN EL MODEL, UNA C. DISTRIB. NOMES POT TENIR UNA CONNEXIO PRINCIPAL, '); 
DBMS_OUTPUT.PUT_LINE('        LA RESTA HA DE SER SECUNDARIES DE RESERVA) ');
DBMS_OUTPUT.PUT_LINE('INSTRUCCIO: PR_ALTA_CONNLINIA(1,99,4,''P'',0,RSP);');

PR_ALTA_CONNLINIA(1,99,4,'P',0,RSP);
DBMS_OUTPUT.PUT_LINE('RSP  ----> '||RSP);
DBMS_OUTPUT.PUT_LINE('');
DBMS_OUTPUT.PUT_LINE('==========================================================================');
DBMS_OUTPUT.PUT_LINE('');



DBMS_OUTPUT.PUT_LINE('TEST : ALTA CONNLINIA  - CORRECTE ');
DBMS_OUTPUT.PUT_LINE('INSTRUCCIO: PR_ALTA_CONNLINIA(99,99,99,''P'',1,RSP);');

PR_ALTA_CONNLINIA(99,99,99,'P',1,RSP);
DBMS_OUTPUT.PUT_LINE('RSP  ----> '||RSP);
DBMS_OUTPUT.PUT_LINE('');
DBMS_OUTPUT.PUT_LINE('==========================================================================');
DBMS_OUTPUT.PUT_LINE('');


END;
/


PROMPT POLSAR UNA TECLA PER CONTINUAR..
PAUSE


---- PROVES ALTA CONNCOMPTADOR


DECLARE
RSP VARCHAR2(300);
BEGIN
--ESBORRO ABANS CONNCOMPTADOR DE PROVA
DELETE CONNCOMPTADOR WHERE IDCOMPTADOR = 99 AND IDCDIST = 99;

DBMS_OUTPUT.PUT_LINE('TEST : ALTA CONNCOMPTADOR (IDCOMPTADOR - IDCDIST) -  CAMPS NULS');
DBMS_OUTPUT.PUT_LINE('INSTRUCCIO: PR_ALTA_CONNCOMPTADOR(1,1,0,''P'',NULL,RSP);');

PR_ALTA_CONNCOMPTADOR(1,1,0,'P',NULL,RSP);	
DBMS_OUTPUT.PUT_LINE('RSP  ----> '||RSP);
DBMS_OUTPUT.PUT_LINE('');
DBMS_OUTPUT.PUT_LINE('==========================================================================');
DBMS_OUTPUT.PUT_LINE('');


DBMS_OUTPUT.PUT_LINE('TEST : ALTA CONNCOMPTADOR (IDCOMPTADOR - IDCDIST) -  NO EXISTEIX COMPTADOR');
DBMS_OUTPUT.PUT_LINE('INSTRUCCIO: PR_ALTA_CONNCOMPTADOR(2222,1,0,''P'',1,RSP);');

PR_ALTA_CONNCOMPTADOR(2222,1,0,'P',1,RSP);	
DBMS_OUTPUT.PUT_LINE('RSP  ----> '||RSP);
DBMS_OUTPUT.PUT_LINE('');
DBMS_OUTPUT.PUT_LINE('==========================================================================');
DBMS_OUTPUT.PUT_LINE('');



DBMS_OUTPUT.PUT_LINE('TEST : ALTA CONNCOMPTADOR (IDCOMPTADOR - IDCDIST) -  NO EXISTEIX CENTRAL DISTRIBUCIO');
DBMS_OUTPUT.PUT_LINE('INSTRUCCIO: PR_ALTA_CONNCOMPTADOR(1,7878,0,''P'',1,RSP);');

PR_ALTA_CONNCOMPTADOR(1,7878,0,'P',1,RSP);	
DBMS_OUTPUT.PUT_LINE('RSP  ----> '||RSP);
DBMS_OUTPUT.PUT_LINE('');
DBMS_OUTPUT.PUT_LINE('==========================================================================');
DBMS_OUTPUT.PUT_LINE('');




DBMS_OUTPUT.PUT_LINE('TEST : ALTA CONNCOMPTADOR (IDCOMPTADOR - IDCDIST) -  JA EXISTEIX LA CONNEXIO');
DBMS_OUTPUT.PUT_LINE('INSTRUCCIO: PR_ALTA_CONNCOMPTADOR(1,1,0,''P'',1,RSP);');

PR_ALTA_CONNCOMPTADOR(1,1,0,'P',1,RSP);	
DBMS_OUTPUT.PUT_LINE('RSP  ----> '||RSP);
DBMS_OUTPUT.PUT_LINE('');
DBMS_OUTPUT.PUT_LINE('==========================================================================');
DBMS_OUTPUT.PUT_LINE('');


DBMS_OUTPUT.PUT_LINE('TEST : ALTA CONNCOMPTADOR (IDCOMPTADOR - IDCDIST) -  ESTAT ERRONI');
DBMS_OUTPUT.PUT_LINE('INSTRUCCIO: PR_ALTA_CONNCOMPTADOR(99,99,0,''P'',3,RSP);');

PR_ALTA_CONNCOMPTADOR(99,99,0,'P',3,RSP);	
DBMS_OUTPUT.PUT_LINE('RSP  ----> '||RSP);
DBMS_OUTPUT.PUT_LINE('');
DBMS_OUTPUT.PUT_LINE('==========================================================================');
DBMS_OUTPUT.PUT_LINE('');


DBMS_OUTPUT.PUT_LINE('TEST : ALTA CONNCOMPTADOR (IDCOMPTADOR - IDCDIST) -  TIPUS DE CONNEXIO ERRONI');
DBMS_OUTPUT.PUT_LINE('INSTRUCCIO: PR_ALTA_CONNCOMPTADOR(99,99,0,''W'',1,RSP);');

PR_ALTA_CONNCOMPTADOR(99,99,0,'W',1,RSP);	
DBMS_OUTPUT.PUT_LINE('RSP  ----> '||RSP);
DBMS_OUTPUT.PUT_LINE('');
DBMS_OUTPUT.PUT_LINE('==========================================================================');
DBMS_OUTPUT.PUT_LINE('');


DBMS_OUTPUT.PUT_LINE('TEST : ALTA CONNCOMPTADOR (IDCOMPTADOR - IDCDIST) -  COMPTADOR JA TE CONNEXIO ACTIVA');
DBMS_OUTPUT.PUT_LINE('      (EN EL MODEL, UN COMPTADOR NOMES POT REBRE D''UNA CENTRAL DISTRIBUCIO, '); 
DBMS_OUTPUT.PUT_LINE('      I TE UNA CONNEXIO ACTIVA I LA RESTA DESACTIVES) ');
DBMS_OUTPUT.PUT_LINE('INSTRUCCIO: PR_ALTA_CONNCOMPTADOR(1,99,0,''S'',1,RSP);');

PR_ALTA_CONNCOMPTADOR(1,99,0,'S',1,RSP);	
DBMS_OUTPUT.PUT_LINE('RSP  ----> '||RSP);
DBMS_OUTPUT.PUT_LINE('');
DBMS_OUTPUT.PUT_LINE('==========================================================================');
DBMS_OUTPUT.PUT_LINE('');


DBMS_OUTPUT.PUT_LINE('TEST : ALTA CONNCOMPTADOR (IDCOMPTADOR - IDCDIST) -  COMPTADOR JA TE CONNEXIO PRINCIPAL');
DBMS_OUTPUT.PUT_LINE('(EN EL SISTEMA, UN COMPTADOR NOMES POT TENIR UNA CONNEXIO PRINCIPAL, '); 
DBMS_OUTPUT.PUT_LINE('         LA RESTA HA DE SER SECUNDARIES DE RESERVA) ');
DBMS_OUTPUT.PUT_LINE('INSTRUCCIO: PR_ALTA_CONNCOMPTADOR(1,99,0,''P'',0,RSP);');

PR_ALTA_CONNCOMPTADOR(1,99,0,'P',0,RSP);	
DBMS_OUTPUT.PUT_LINE('RSP  ----> '||RSP);
DBMS_OUTPUT.PUT_LINE('');
DBMS_OUTPUT.PUT_LINE('==========================================================================');
DBMS_OUTPUT.PUT_LINE('');


	
DBMS_OUTPUT.PUT_LINE('TEST : ALTA CONNCOMPTADOR (IDCOMPTADOR - IDCDIST) -  CORRECTE');
DBMS_OUTPUT.PUT_LINE('INSTRUCCIO: PR_ALTA_CONNCOMPTADOR(99,99,0,''P'',1,RSP);');

PR_ALTA_CONNCOMPTADOR(99,99,0,'P',1,RSP);	
DBMS_OUTPUT.PUT_LINE('RSP  ----> '||RSP);
DBMS_OUTPUT.PUT_LINE('');
DBMS_OUTPUT.PUT_LINE('==========================================================================');
DBMS_OUTPUT.PUT_LINE('');


END;
/

PROMPT POLSAR UNA TECLA PER CONTINUAR..
PAUSE


--- PROVES ALTA LECTURES

DECLARE
RSP VARCHAR2(300);
BEGIN
DBMS_OUTPUT.PUT_LINE('TEST : ALTA LECTURA - CAMPS AMB VALORS NULS');
DBMS_OUTPUT.PUT_LINE('INSTRUCCIO: PR_ALTA_LECTURA(0,null,''31/05/2012'',1300,''T'',RSP);');

PR_ALTA_LECTURA(0,null,'31/05/2012',300,'T',RSP);
DBMS_OUTPUT.PUT_LINE('RSP  ----> '||RSP);
DBMS_OUTPUT.PUT_LINE('');
DBMS_OUTPUT.PUT_LINE('==========================================================================');
DBMS_OUTPUT.PUT_LINE('');


DBMS_OUTPUT.PUT_LINE('TEST : ALTA LECTURA - COMPTADOR NO EXISTEIX ');
DBMS_OUTPUT.PUT_LINE('INSTRUCCIO: PR_ALTA_LECTURA(0,8787,''31/05/2012'',300,''T'',RSP);');

PR_ALTA_LECTURA(0,8787,'31/05/2012',300,'T',RSP);
DBMS_OUTPUT.PUT_LINE('RSP  ----> '||RSP);
DBMS_OUTPUT.PUT_LINE('');
DBMS_OUTPUT.PUT_LINE('==========================================================================');
DBMS_OUTPUT.PUT_LINE('');


DBMS_OUTPUT.PUT_LINE('TEST : ALTA LECTURA - LECTURA AMB SIGNE NEGATIU');
DBMS_OUTPUT.PUT_LINE('INSTRUCCIO: PR_ALTA_LECTURA(0,1,''31/05/2012'',-300,''T'',RSP);');

PR_ALTA_LECTURA(0,1,'31/05/2012',-300,'T',RSP);
DBMS_OUTPUT.PUT_LINE('RSP  ----> '||RSP);
DBMS_OUTPUT.PUT_LINE('');
DBMS_OUTPUT.PUT_LINE('==========================================================================');
DBMS_OUTPUT.PUT_LINE('');



DBMS_OUTPUT.PUT_LINE('TEST : ALTA LECTURA - LECTURA AMB DATA ANTERIOR A LA ULTIMA FETA');

DBMS_OUTPUT.PUT_LINE('NOTA: LA ULTIMA DE LES PROVES ES AMB DATA 30/04/2012');
DBMS_OUTPUT.PUT_LINE('INSTRUCCIO: PR_ALTA_LECTURA(0,1,''31/10/2011'',300,''T'',RSP);');
PR_ALTA_LECTURA(0,1,'31/10/2011',300,'T',RSP);
DBMS_OUTPUT.PUT_LINE('RSP  ----> '||RSP);
DBMS_OUTPUT.PUT_LINE('');
DBMS_OUTPUT.PUT_LINE('==========================================================================');
DBMS_OUTPUT.PUT_LINE('');




DBMS_OUTPUT.PUT_LINE('TEST : ALTA LECTURA - TIPUS LECTURA ERRONI (NI ''T''ELEMATICA NI ''P''RESENCIAL)');
DBMS_OUTPUT.PUT_LINE('INSTRUCCIO: PR_ALTA_LECTURA(0,1,''31/05/2012'',300,''W'',RSP);');
PR_ALTA_LECTURA(0,1,'31/05/2012',300,'W',RSP);
DBMS_OUTPUT.PUT_LINE('RSP  ----> '||RSP);
DBMS_OUTPUT.PUT_LINE('');
DBMS_OUTPUT.PUT_LINE('==========================================================================');
DBMS_OUTPUT.PUT_LINE('');



DBMS_OUTPUT.PUT_LINE('TEST : ALTA LECTURA -  ES SOBREPASSARIA EL MAXKWH ANUAL DE LA C. DE DISTRIBUCIO ');
DBMS_OUTPUT.PUT_LINE('INSTRUCCIO: PR_ALTA_LECTURA(0,2,''31/05/2012'',2000,''T'',RSP);');
PR_ALTA_LECTURA(0,2,'31/05/2012',2000,'T',RSP);
DBMS_OUTPUT.PUT_LINE('RSP  ----> '||RSP);
DBMS_OUTPUT.PUT_LINE('');
DBMS_OUTPUT.PUT_LINE('==========================================================================');
DBMS_OUTPUT.PUT_LINE('');



DBMS_OUTPUT.PUT_LINE('TEST : ALTA LECTURA -  ES SOBREPASSARIA EL MAXKWH ANUAL DE LA LINIA ');
DBMS_OUTPUT.PUT_LINE('     ( ANOTO LECTURES DE 2 COMPTADORS DIFERENTS QUE PENGEN DE ');
DBMS_OUTPUT.PUT_LINE('       LA MATEIXA LINIA LA SEGONA LECTURA FA SOBREPASSAR EL MAXIM KWH )');
DBMS_OUTPUT.PUT_LINE('INSTRUCCIO: PR_ALTA_LECTURA(0,29,''31/05/2012'',800,''T'',RSP);');
PR_ALTA_LECTURA(0,29,'31/05/2012',1000,'T',RSP);
DBMS_OUTPUT.PUT_LINE('INSTRUCCIO: PR_ALTA_LECTURA(0,30,''31/05/2012'',800,''T'',RSP);');
PR_ALTA_LECTURA(0,30,'31/05/2012',1100,'T',RSP);
DBMS_OUTPUT.PUT_LINE('RSP  ----> '||RSP);
DBMS_OUTPUT.PUT_LINE('');
DBMS_OUTPUT.PUT_LINE('==========================================================================');
DBMS_OUTPUT.PUT_LINE('');



DBMS_OUTPUT.PUT_LINE('TEST : ALTA LECTURA -  CORRECTA ');
DBMS_OUTPUT.PUT_LINE('INSTRUCCIO: PR_ALTA_LECTURA(0,1,''31/05/2012'',450,''T'',RSP);');
PR_ALTA_LECTURA(0,1,'31/05/2012',450,'T',RSP);
DBMS_OUTPUT.PUT_LINE('RSP  ----> '||RSP);
DBMS_OUTPUT.PUT_LINE('');
DBMS_OUTPUT.PUT_LINE('==========================================================================');
DBMS_OUTPUT.PUT_LINE('');


END;

/
PROMPT FI DE LES PROVES D''ALTES.
@