SET SERVEROUTPUT ON
SET LINESIZE 120
/*********************************************************************
	AQUEST SCRIPT REALITZA LES PROVES DELS PROCEDIMENTS DE BAIXA
	EN EL ORDRE SEGENT:

	- BAIXA COMPTADOR
	- BAIXA CENTRAL DISTRIBUCI
	- BAIXA LNIA
	- BAIXA CENTRAL PRODUCCI
	- BAIXA CONTRACTE
	- BAIXA CLIENT

	NO TOTS ELS ELEMENTS DE LA BBDD ADMETEN BAIXA.

***********************************************************************/


DECLARE
RSP VARCHAR2(300);
BEGIN

DBMS_OUTPUT.PUT_LINE('TEST : BAIXA COMPTADOR - COMPTADOR NO EXISTEIX');
DBMS_OUTPUT.PUT_LINE('INSTRUCCIO: PR_BAIXA_COMPTADOR(77575,NULL,RSP);');
PR_BAIXA_COMPTADOR(77575,NULL,RSP);
DBMS_OUTPUT.PUT_LINE('RSP  ----> '||RSP);
DBMS_OUTPUT.PUT_LINE('');
DBMS_OUTPUT.PUT_LINE('==========================================================================');
DBMS_OUTPUT.PUT_LINE('');



DBMS_OUTPUT.PUT_LINE('TEST : BAIXA COMPTADOR - IDCOMPTADOR AMB VALOR NULL');
DBMS_OUTPUT.PUT_LINE('INSTRUCCIO: PR_BAIXA_COMPTADOR(NULL,''01/01/2012'',RSP);');
PR_BAIXA_COMPTADOR(NULL,'01/01/2012',RSP);
DBMS_OUTPUT.PUT_LINE('RSP  ----> '||RSP);
DBMS_OUTPUT.PUT_LINE('');
DBMS_OUTPUT.PUT_LINE('==========================================================================');
DBMS_OUTPUT.PUT_LINE('');


DBMS_OUTPUT.PUT_LINE('TEST : BAIXA COMPTADOR - DATA DE BAIXA MENOR A LA ULTIMA LECTURA (INCONGRUENT)');
DBMS_OUTPUT.PUT_LINE('INSTRUCCIO: PR_BAIXA_COMPTADOR(14,''01/01/1999'',RSP);');
PR_BAIXA_COMPTADOR(14,'01/01/1999',RSP);
DBMS_OUTPUT.PUT_LINE('RSP  ----> '||RSP);
DBMS_OUTPUT.PUT_LINE('');
DBMS_OUTPUT.PUT_LINE('==========================================================================');
DBMS_OUTPUT.PUT_LINE('');


DBMS_OUTPUT.PUT_LINE('TEST : BAIXA COMPTADOR - CORRECTE');
DBMS_OUTPUT.PUT_LINE('INSTRUCCIO: PR_BAIXA_COMPTADOR(2,NULL,RSP);');
PR_BAIXA_COMPTADOR(2,NULL,RSP);
DBMS_OUTPUT.PUT_LINE('RSP  ----> '||RSP);
DBMS_OUTPUT.PUT_LINE('');
DBMS_OUTPUT.PUT_LINE('==========================================================================');
DBMS_OUTPUT.PUT_LINE('');




END;

/
PROMPT POLSAR UNA TECLA PER CONTINUAR...
PAUSE





DECLARE
RSP VARCHAR2(300);
BEGIN

DBMS_OUTPUT.PUT_LINE('TEST : BAIXA CENTRAL DISTRIBUCIO - PARAM. IDCDIST NO EXISTEIX');
DBMS_OUTPUT.PUT_LINE('INSTRUCCIO: PR_BAIXA_CENTRALDIST(77575,NULL,RSP);');
PR_BAIXA_CENTRALDIST(77575,NULL,RSP);
DBMS_OUTPUT.PUT_LINE('RSP  ----> '||RSP);
DBMS_OUTPUT.PUT_LINE('');
DBMS_OUTPUT.PUT_LINE('==========================================================================');
DBMS_OUTPUT.PUT_LINE('');

DBMS_OUTPUT.PUT_LINE('TEST : BAIXA CENTRAL DISTRIBUCIO - PARAM. IDCDIST AMB VALOR NULL');
DBMS_OUTPUT.PUT_LINE('INSTRUCCIO: PR_BAIXA_CENTRALDIST(NULL,''01/01/2012'',RSP);');
PR_BAIXA_CENTRALDIST(NULL,'01/01/2012',RSP);
DBMS_OUTPUT.PUT_LINE('RSP  ----> '||RSP);
DBMS_OUTPUT.PUT_LINE('');
DBMS_OUTPUT.PUT_LINE('==========================================================================');
DBMS_OUTPUT.PUT_LINE('');

DBMS_OUTPUT.PUT_LINE('TEST : BAIXA CENTRAL DISTRIBUCIO - DATA DE BAIXA MENOR A L''ALTA');
DBMS_OUTPUT.PUT_LINE('INSTRUCCIO: PR_BAIXA_CENTRALDIST(14,''01/01/1999'',RSP);');
PR_BAIXA_CENTRALDIST(14,'01/01/1999',RSP);
DBMS_OUTPUT.PUT_LINE('RSP  ----> '||RSP);
DBMS_OUTPUT.PUT_LINE('');
DBMS_OUTPUT.PUT_LINE('==========================================================================');
DBMS_OUTPUT.PUT_LINE('');


DBMS_OUTPUT.PUT_LINE('TEST : BAIXA CENTRAL DISTRIBUCIO - COMPTADORS ASSOCIATS A REUBICAR O ESBORRAR');
DBMS_OUTPUT.PUT_LINE('       (EL SISTEMA ELS LLISTARA PER SABER QUINS SON)');
DBMS_OUTPUT.PUT_LINE('INSTRUCCIO: PR_BAIXA_CENTRALDIST(15,''01/01/2012'',RSP);');
PR_BAIXA_CENTRALDIST(15,'01/01/2012',RSP);
DBMS_OUTPUT.PUT_LINE('RSP  ----> '||RSP);
DBMS_OUTPUT.PUT_LINE('');
DBMS_OUTPUT.PUT_LINE('==========================================================================');
DBMS_OUTPUT.PUT_LINE('');


DBMS_OUTPUT.PUT_LINE('TEST : BAIXA CENTRAL DISTRIBUCIO - CORRECTE');
DBMS_OUTPUT.PUT_LINE('       (ESBORREM PRIMER ELS COMPTADOR QUE TE)');

DBMS_OUTPUT.PUT_LINE('INSTRUCCIO: PR_BAIXA_COMPTADOR(29,NULL,RSP);');
PR_BAIXA_COMPTADOR(29,'31/05/2012',RSP);
DBMS_OUTPUT.PUT_LINE('RSP  ----> '||RSP);
DBMS_OUTPUT.PUT_LINE('INSTRUCCIO: PR_BAIXA_COMPTADOR(30,NULL,RSP);');
PR_BAIXA_COMPTADOR(30,NULL,RSP);
DBMS_OUTPUT.PUT_LINE('RSP  ----> '||RSP);

DBMS_OUTPUT.PUT_LINE('       (ARA PROCEDIM A DONAR DE BAIXA)');

DBMS_OUTPUT.PUT_LINE('INSTRUCCIO: PR_BAIXA_CENTRALDIST(15,''31/04/2012'',RSP);');
PR_BAIXA_CENTRALDIST(15,'01/01/2012',RSP);
DBMS_OUTPUT.PUT_LINE('RSP  ----> '||RSP);
DBMS_OUTPUT.PUT_LINE('');
DBMS_OUTPUT.PUT_LINE('==========================================================================');
DBMS_OUTPUT.PUT_LINE('');



END;

/

PROMPT POLSAR UNA TECLA PER CONTINUAR...
PAUSE







DECLARE
RSP VARCHAR2(300);
BEGIN

DBMS_OUTPUT.PUT_LINE('TEST : BAIXA LINIA - PARAM. IDCLINIA NO EXISTEIX');
DBMS_OUTPUT.PUT_LINE('INSTRUCCIO: PR_BAIXA_LINIA(77575,NULL,RSP);');
PR_BAIXA_LINIA(77575,NULL,RSP);
DBMS_OUTPUT.PUT_LINE('RSP  ----> '||RSP);
DBMS_OUTPUT.PUT_LINE('');
DBMS_OUTPUT.PUT_LINE('==========================================================================');
DBMS_OUTPUT.PUT_LINE('');

DBMS_OUTPUT.PUT_LINE('TEST : BAIXA LINIA - PARAM. LINIA AMB VALOR NULL');
DBMS_OUTPUT.PUT_LINE('INSTRUCCIO: PR_BAIXA_LINIA(NULL,''01/01/2012'',RSP);');
PR_BAIXA_LINIA(NULL,'01/01/2012',RSP);
DBMS_OUTPUT.PUT_LINE('RSP  ----> '||RSP);
DBMS_OUTPUT.PUT_LINE('');
DBMS_OUTPUT.PUT_LINE('==========================================================================');
DBMS_OUTPUT.PUT_LINE('');


DBMS_OUTPUT.PUT_LINE('TEST : BAIXA LINIA - AMB C.DISTRIBUCIO ASSOCIADES');
DBMS_OUTPUT.PUT_LINE('       (EL SISTEMA LES LLISTARA PER SABER QUINES SON)');
DBMS_OUTPUT.PUT_LINE('INSTRUCCIO: PR_BAIXA_LINIA(3,''01/01/2012'',RSP);');
PR_BAIXA_LINIA(3,'01/01/2012',RSP);
DBMS_OUTPUT.PUT_LINE('RSP  ----> '||RSP);
DBMS_OUTPUT.PUT_LINE('');
DBMS_OUTPUT.PUT_LINE('==========================================================================');
DBMS_OUTPUT.PUT_LINE('');


DBMS_OUTPUT.PUT_LINE('TEST : BAIXA LINIA - CORRECTE');
DBMS_OUTPUT.PUT_LINE('      ');
DBMS_OUTPUT.PUT_LINE('PRIMER, POSEM INACTIVES LES CONNEXIONS PER PODER ESBORRAR');
DBMS_OUTPUT.PUT_LINE('INSTRUCCIO: PR_MODIFICA_CONNLINIA(4,3,1,''B'',0,RSP);');
PR_MODIFICA_CONNLINIA(4,3,1,'B',0,RSP);
DBMS_OUTPUT.PUT_LINE('RSP  ----> '||RSP);
DBMS_OUTPUT.PUT_LINE('INSTRUCCIO: PR_MODIFICA_CONNLINIA(7,3,1,''B'',0,RSP);');
PR_MODIFICA_CONNLINIA(7,3,1,'B',0,RSP);
DBMS_OUTPUT.PUT_LINE('RSP  ----> '||RSP);

DBMS_OUTPUT.PUT_LINE(' A CONTINUACIO,  REUBIQUEM LES C. DIST. QUE PENGEN');
DBMS_OUTPUT.PUT_LINE('INSTRUCCIO: PR_ALTA_CONNLINIA(4,2,1,''P'',1,RSP);');
PR_ALTA_CONNLINIA(4,2,1,'P',1,RSP);
DBMS_OUTPUT.PUT_LINE('RSP  ----> '||RSP);
DBMS_OUTPUT.PUT_LINE('INSTRUCCIO: PR_ALTA_CONNLINIA(7,2,1,''S'',0,RSP);');
PR_ALTA_CONNLINIA(7,2,1,'S',0,RSP);
DBMS_OUTPUT.PUT_LINE('RSP  ----> '||RSP);

DBMS_OUTPUT.PUT_LINE(' I ARA, JA ES POT ESBORRAR:');

DBMS_OUTPUT.PUT_LINE('INSTRUCCIO: PR_BAIXA_LINIA(3,NULL,RSP);');
PR_BAIXA_LINIA(3,NULL,RSP);
DBMS_OUTPUT.PUT_LINE('RSP  ----> '||RSP);
DBMS_OUTPUT.PUT_LINE('');
DBMS_OUTPUT.PUT_LINE('==========================================================================');
DBMS_OUTPUT.PUT_LINE('');



END;

/

PROMPT POLSAR UNA TECLA PER CONTINUAR...

PAUSE


DECLARE
RSP VARCHAR2(300);
BEGIN

DBMS_OUTPUT.PUT_LINE('TEST : BAIXA CENTRAL PRODUCCIO - PARAM. IDCPROD NO EXISTEIX');
DBMS_OUTPUT.PUT_LINE('INSTRUCCIO: PR_BAIXA_CENTRALPROD(77575,NULL,RSP);');
PR_BAIXA_CENTRALPROD(77575,NULL,RSP);
DBMS_OUTPUT.PUT_LINE('RSP  ----> '||RSP);
DBMS_OUTPUT.PUT_LINE('');
DBMS_OUTPUT.PUT_LINE('==========================================================================');
DBMS_OUTPUT.PUT_LINE('');

DBMS_OUTPUT.PUT_LINE('TEST : BAIXA CENTRAL PRODUCCIO - PARAM. IDCPROD AMB VALOR NULL');
DBMS_OUTPUT.PUT_LINE('INSTRUCCIO: PR_BAIXA_CENTRALPROD(NULL,''01/01/2012'',RSP);');
PR_BAIXA_CENTRALPROD(NULL,'01/01/2012',RSP);
DBMS_OUTPUT.PUT_LINE('RSP  ----> '||RSP);
DBMS_OUTPUT.PUT_LINE('');
DBMS_OUTPUT.PUT_LINE('==========================================================================');
DBMS_OUTPUT.PUT_LINE('');

DBMS_OUTPUT.PUT_LINE('TEST : BAIXA CENTRAL PRODUCCIO - DATA DE BAIXA MENOR A LA D''ALTA');
DBMS_OUTPUT.PUT_LINE('INSTRUCCIO: PR_BAIXA_CENTRALPROD(4,''01/01/1970'',RSP);');
PR_BAIXA_CENTRALPROD(4,'01/01/1970',RSP);
DBMS_OUTPUT.PUT_LINE('RSP  ----> '||RSP);
DBMS_OUTPUT.PUT_LINE('');
DBMS_OUTPUT.PUT_LINE('==========================================================================');
DBMS_OUTPUT.PUT_LINE('');


DBMS_OUTPUT.PUT_LINE('TEST : BAIXA CENTRAL PRODUCCIO - AMB C.DISTRIBUCIO ASSOCIADES');
DBMS_OUTPUT.PUT_LINE('       (EL SISTEMA LES LLISTARA PER SABER QUINES SON)');
DBMS_OUTPUT.PUT_LINE('INSTRUCCIO: PR_BAIXA_CENTRALPROD(1,''01/01/2012'',RSP);');
PR_BAIXA_CENTRALPROD(1,'01/01/2012',RSP);
DBMS_OUTPUT.PUT_LINE('RSP  ----> '||RSP);
DBMS_OUTPUT.PUT_LINE('');
DBMS_OUTPUT.PUT_LINE('==========================================================================');
DBMS_OUTPUT.PUT_LINE('');


DBMS_OUTPUT.PUT_LINE('TEST : BAIXA CENTRALPROD - CORRECTE');
DBMS_OUTPUT.PUT_LINE('FAIG LA PROVA AMB LA IDCPROD 99 QUE ES VA CREAR');
DBMS_OUTPUT.PUT_LINE('ALS TESTS D''ALTA');

DBMS_OUTPUT.PUT_LINE('');
DBMS_OUTPUT.PUT_LINE('INSTRUCCIO: PR_BAIXA_CENTRALPROD(99,NULL,RSP);');
PR_BAIXA_CENTRALPROD(99,NULL,RSP);
DBMS_OUTPUT.PUT_LINE('RSP  ----> '||RSP);

DBMS_OUTPUT.PUT_LINE('');

DBMS_OUTPUT.PUT_LINE('PERQUE DEIXI ESBORRAR, PRIMER HE DE DEIXARLA ''LLIURE'');');
DBMS_OUTPUT.PUT_LINE('INSTRUCCIO: PR_BAIXA_COMPTADOR(99,NULL,RSP);');
PR_BAIXA_COMPTADOR(99,NULL,RSP);
DBMS_OUTPUT.PUT_LINE('INSTRUCCIO: PR_BAIXA_CENTRALDIST(99,NULL,RSP);');
PR_BAIXA_CENTRALDIST(99,NULL,RSP);

DBMS_OUTPUT.PUT_LINE('');
DBMS_OUTPUT.PUT_LINE('ARA SI QUE DEIXARA ESBORRAR LA CENTRAL DE PRODUCCIO 99;');
DBMS_OUTPUT.PUT_LINE('');

DBMS_OUTPUT.PUT_LINE('INSTRUCCIO: PR_BAIXA_CENTRALPROD(99,NULL,RSP);');
PR_BAIXA_CENTRALPROD(99,NULL,RSP);
DBMS_OUTPUT.PUT_LINE('RSP  ----> '||RSP);


DBMS_OUTPUT.PUT_LINE('');
DBMS_OUTPUT.PUT_LINE('==========================================================================');
DBMS_OUTPUT.PUT_LINE('');




END;

/
PROMPT POLSAR UNA TECLA PER CONTINUAR...

PAUSE


DECLARE
RSP VARCHAR2(300);
BEGIN

DBMS_OUTPUT.PUT_LINE('TEST : BAIXA CONTRACTE - PARAM. IDCODI NO EXISTEIX');
DBMS_OUTPUT.PUT_LINE('INSTRUCCIO: PR_BAIXA_CONTRACTE(77575,NULL,RSP);');
PR_BAIXA_CONTRACTE(77575,NULL,RSP);
DBMS_OUTPUT.PUT_LINE('RSP  ----> '||RSP);
DBMS_OUTPUT.PUT_LINE('');
DBMS_OUTPUT.PUT_LINE('==========================================================================');
DBMS_OUTPUT.PUT_LINE('');

DBMS_OUTPUT.PUT_LINE('TEST : BAIXA CONTRACTE - PARAM. CODI AMB VALOR NULL');
DBMS_OUTPUT.PUT_LINE('INSTRUCCIO: PR_BAIXA_CONTRACTE(NULL,''01/01/2012'',RSP);');
PR_BAIXA_CONTRACTE(NULL,'01/01/2012',RSP);
DBMS_OUTPUT.PUT_LINE('RSP  ----> '||RSP);
DBMS_OUTPUT.PUT_LINE('');
DBMS_OUTPUT.PUT_LINE('==========================================================================');
DBMS_OUTPUT.PUT_LINE('');

DBMS_OUTPUT.PUT_LINE('TEST : BAIXA CONTRACTE - DATA DE BAIXA MENOR A LA D''ALTA');
DBMS_OUTPUT.PUT_LINE('INSTRUCCIO: PR_BAIXA_CONTRACTE(4,''01/01/1970'',RSP);');
PR_BAIXA_CONTRACTE(4,'01/01/1970',RSP);
DBMS_OUTPUT.PUT_LINE('RSP  ----> '||RSP);
DBMS_OUTPUT.PUT_LINE('');
DBMS_OUTPUT.PUT_LINE('==========================================================================');
DBMS_OUTPUT.PUT_LINE('');


DBMS_OUTPUT.PUT_LINE('TEST : BAIXA CONTRACTE - CORRECTE');
DBMS_OUTPUT.PUT_LINE('INSTRUCCIO: PR_BAIXA_CONTRACTE(4,NULL,RSP);');
PR_BAIXA_CONTRACTE(4,NULL,RSP);
DBMS_OUTPUT.PUT_LINE('RSP  ----> '||RSP);
DBMS_OUTPUT.PUT_LINE('');
DBMS_OUTPUT.PUT_LINE('==========================================================================');
DBMS_OUTPUT.PUT_LINE('');



END;

/

PROMPT POLSAR UNA TECLA PER CONTINUAR...
PAUSE


DECLARE
RSP VARCHAR2(300);
BEGIN

DBMS_OUTPUT.PUT_LINE('TEST : BAIXA CLIENT - PARAM. IDCLIENT NO EXISTEIX');
DBMS_OUTPUT.PUT_LINE('INSTRUCCIO: PR_BAIXA_CLIENT(123456,NULL,RSP);');
PR_BAIXA_CLIENT(123456,NULL,RSP);
DBMS_OUTPUT.PUT_LINE('RSP  ----> '||RSP);
DBMS_OUTPUT.PUT_LINE('');
DBMS_OUTPUT.PUT_LINE('==========================================================================');
DBMS_OUTPUT.PUT_LINE('');

DBMS_OUTPUT.PUT_LINE('TEST : BAIXA CLIENT - PARAM. IDCLIENT AMB VALOR NULL');
DBMS_OUTPUT.PUT_LINE('INSTRUCCIO: PR_BAIXA_CLIENT(NULL,''01/01/2012'',RSP);');
PR_BAIXA_CLIENT(NULL,'01/01/2012',RSP);
DBMS_OUTPUT.PUT_LINE('RSP  ----> '||RSP);
DBMS_OUTPUT.PUT_LINE('');
DBMS_OUTPUT.PUT_LINE('==========================================================================');
DBMS_OUTPUT.PUT_LINE('');

DBMS_OUTPUT.PUT_LINE('TEST : BAIXA CLIENT - DATA DE BAIXA MENOR A LA D''ALTA');
DBMS_OUTPUT.PUT_LINE('INSTRUCCIO: PR_BAIXA_CLIENT(4,''01/01/1970'',RSP);');
PR_BAIXA_CLIENT(4,'01/01/1970',RSP);
DBMS_OUTPUT.PUT_LINE('RSP  ----> '||RSP);
DBMS_OUTPUT.PUT_LINE('');
DBMS_OUTPUT.PUT_LINE('==========================================================================');
DBMS_OUTPUT.PUT_LINE('');

DBMS_OUTPUT.PUT_LINE('TEST : BAIXA CLIENT - CORRECTE');
DBMS_OUTPUT.PUT_LINE('INSTRUCCIO: PR_BAIXA_CLIENT(5,NULL,RSP);');
PR_BAIXA_CLIENT(5,NULL,RSP);
DBMS_OUTPUT.PUT_LINE('RSP  ----> '||RSP);
DBMS_OUTPUT.PUT_LINE('');
DBMS_OUTPUT.PUT_LINE('==========================================================================');
DBMS_OUTPUT.PUT_LINE('');



END;

/
PROMPT FI DE LES PROVES DE BAIXES...
PAUSE




